import { IPublicApiCommonUI, IPublicTypeContextMenuAction } from '@alilc/lowcode-types';
import { HelpTip, IEditor, Tip as InnerTip, Title as InnerTitle } from '@alilc/lowcode-editor-core';
import { Table } from '@alifd/next';
import { editorSymbol } from '../symbols';
import { ReactElement } from 'react';
export declare class CommonUI implements IPublicApiCommonUI {
    [editorSymbol]: IEditor;
    Balloon: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/balloon").BalloonProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        readonly props: import("@alifd/next/types/balloon").BalloonV1Props & import("@alifd/next/types/balloon").BalloonV2Props;
        _onVisibleChange(visible: boolean, trigger: string): void;
        _onClose(e: import("react").MouseEvent<Element, MouseEvent>): void;
        _onPosition(res: {
            align?: string[] | undefined;
            config: {
                placement: string;
                points: string;
            };
            style?: CSSCounterStyleRule | undefined;
        }): void;
        beforePosition: (result: {
            config: {
                placement: import("@alifd/next/types/balloon").AlignType;
            };
            style: {
                left: number;
                top: number;
            };
        }, obj: {
            target: {
                width: number;
                height: number;
            };
        }) => {
            config: {
                placement: import("@alifd/next/types/balloon").AlignType;
            };
            style: {
                left: number;
                top: number;
            };
        };
        render(): import("react").JSX.Element;
        context: any;
        setState<K extends keyof import("@alifd/next/types/balloon/types").BalloonState>(state: import("@alifd/next/types/balloon/types").BalloonState | ((prevState: Readonly<import("@alifd/next/types/balloon/types").BalloonState>, props: Readonly<import("@alifd/next/types/balloon").BalloonProps>) => import("@alifd/next/types/balloon/types").BalloonState | Pick<import("@alifd/next/types/balloon/types").BalloonState, K> | null) | Pick<import("@alifd/next/types/balloon/types").BalloonState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        state: Readonly<import("@alifd/next/types/balloon/types").BalloonState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/balloon").BalloonProps>, nextState: Readonly<import("@alifd/next/types/balloon/types").BalloonState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/balloon").BalloonProps>, prevState: Readonly<import("@alifd/next/types/balloon/types").BalloonState>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/balloon").BalloonProps>, prevState: Readonly<import("@alifd/next/types/balloon/types").BalloonState>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/balloon").BalloonProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/balloon").BalloonProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/balloon").BalloonProps>, nextState: Readonly<import("@alifd/next/types/balloon/types").BalloonState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/balloon").BalloonProps>, nextState: Readonly<import("@alifd/next/types/balloon/types").BalloonState>, nextContext: any): void;
    }, {}> & {
        Tooltip: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/balloon").TooltipProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/balloon/tooltip").default, {}>;
        Inner: typeof import("@alifd/next/types/balloon/inner").default;
    };
    Breadcrumb: any;
    Button: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/button").ButtonProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/button/view/button").default, {}> & {
        Group: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/button").GroupProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/button/view/group").ButtonGroup, {}>;
    };
    Card: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/card/card").default, {}> & {
        Divider: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardDividerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            render(): import("react").JSX.Element;
            context: any;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/card").CardDividerProps>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/card").CardDividerProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardDividerProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardDividerProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardDividerProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardDividerProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardDividerProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardDividerProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardDividerProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
        Header: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardHeaderProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            render(): import("react").JSX.Element;
            context: any;
            setState<K_1 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/card").CardHeaderProps>) => {} | Pick<{}, K_1> | null) | Pick<{}, K_1> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/card").CardHeaderProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardHeaderProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardHeaderProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardHeaderProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardHeaderProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardHeaderProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardHeaderProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardHeaderProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
        Media: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardMediaProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            render(): import("react").JSX.Element;
            context: any;
            setState<K_2 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/card").CardMediaProps>) => {} | Pick<{}, K_2> | null) | Pick<{}, K_2> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/card").CardMediaProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardMediaProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardMediaProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardMediaProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardMediaProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardMediaProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardMediaProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardMediaProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
        Content: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardContentProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            render(): import("react").JSX.Element;
            context: any;
            setState<K_3 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/card").CardContentProps>) => {} | Pick<{}, K_3> | null) | Pick<{}, K_3> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/card").CardContentProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardContentProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardContentProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardContentProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardContentProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardContentProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardContentProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardContentProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
        Actions: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardActionsProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            render(): import("react").JSX.Element;
            context: any;
            setState<K_4 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/card").CardActionsProps>) => {} | Pick<{}, K_4> | null) | Pick<{}, K_4> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/card").CardActionsProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardActionsProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardActionsProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardActionsProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardActionsProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardActionsProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardActionsProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardActionsProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
        BulletHeader: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardBulletHeaderProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            render(): import("react").JSX.Element | null;
            context: any;
            setState<K_5 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps>) => {} | Pick<{}, K_5> | null) | Pick<{}, K_5> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardBulletHeaderProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
        CollaspeContent: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardCollapseContentProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            content: HTMLDivElement;
            footer: HTMLDivElement;
            componentDidMount(): void;
            componentDidUpdate(): void;
            handleToggle: () => void;
            _setNeedMore(): void;
            _setContentHeight(): void;
            _getNodeChildrenHeight(node?: HTMLDivElement | undefined): number;
            _contentRefHandler: (ref: HTMLDivElement) => void;
            saveFooter: (ref: HTMLDivElement) => void;
            render(): import("react").JSX.Element;
            context: any;
            setState<K_6 extends keyof import("@alifd/next/types/card/collapse-content").CardCollapseContentState>(state: import("@alifd/next/types/card/collapse-content").CardCollapseContentState | ((prevState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>, props: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>) => import("@alifd/next/types/card/collapse-content").CardCollapseContentState | Pick<import("@alifd/next/types/card/collapse-content").CardCollapseContentState, K_6> | null) | Pick<import("@alifd/next/types/card/collapse-content").CardCollapseContentState, K_6> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/card").CardCollapseContentProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, prevState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>, nextContext: any): void;
        }, {}>;
        CollapseContent: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/card").CardCollapseContentProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            content: HTMLDivElement;
            footer: HTMLDivElement;
            componentDidMount(): void;
            componentDidUpdate(): void;
            handleToggle: () => void;
            _setNeedMore(): void;
            _setContentHeight(): void;
            _getNodeChildrenHeight(node?: HTMLDivElement | undefined): number;
            _contentRefHandler: (ref: HTMLDivElement) => void;
            saveFooter: (ref: HTMLDivElement) => void;
            render(): import("react").JSX.Element;
            context: any;
            setState<K_6 extends keyof import("@alifd/next/types/card/collapse-content").CardCollapseContentState>(state: import("@alifd/next/types/card/collapse-content").CardCollapseContentState | ((prevState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>, props: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>) => import("@alifd/next/types/card/collapse-content").CardCollapseContentState | Pick<import("@alifd/next/types/card/collapse-content").CardCollapseContentState, K_6> | null) | Pick<import("@alifd/next/types/card/collapse-content").CardCollapseContentState, K_6> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/card").CardCollapseContentProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, prevState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/card").CardCollapseContentProps>, nextState: Readonly<import("@alifd/next/types/card/collapse-content").CardCollapseContentState>, nextContext: any): void;
        }, {}>;
    };
    Checkbox: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<(import("@alifd/next/types/checkbox").CheckboxProps | (import("@alifd/next/types/checkbox").CheckboxProps & {
        children?: import("react").ReactNode;
    })) & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("react").Component<import("@alifd/next/types/checkbox").CheckboxProps, any, any>, {}> & {
        Group: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/checkbox").GroupProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            getChildContext(): {
                __group__: boolean;
                onChange: (currentValue: import("@alifd/next/types/checkbox").ValueItem, event: import("react").ChangeEvent<HTMLInputElement>) => void;
                selectedValue: import("@alifd/next/types/checkbox").ValueItem[];
                disabled: boolean | undefined;
            };
            onChange(currentValue: import("@alifd/next/types/checkbox").ValueItem, event: import("react").ChangeEvent<HTMLInputElement>): void;
            render(): import("react").JSX.Element;
            context: any;
            setState<K extends "value">(state: import("@alifd/next/types/checkbox/types").GroupState | ((prevState: Readonly<import("@alifd/next/types/checkbox/types").GroupState>, props: Readonly<import("@alifd/next/types/checkbox").GroupProps>) => import("@alifd/next/types/checkbox/types").GroupState | Pick<import("@alifd/next/types/checkbox/types").GroupState, K> | null) | Pick<import("@alifd/next/types/checkbox/types").GroupState, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/checkbox").GroupProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/checkbox/types").GroupState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/checkbox").GroupProps>, nextState: Readonly<import("@alifd/next/types/checkbox/types").GroupState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/checkbox").GroupProps>, prevState: Readonly<import("@alifd/next/types/checkbox/types").GroupState>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/checkbox").GroupProps>, prevState: Readonly<import("@alifd/next/types/checkbox/types").GroupState>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/checkbox").GroupProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/checkbox").GroupProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/checkbox").GroupProps>, nextState: Readonly<import("@alifd/next/types/checkbox/types").GroupState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/checkbox").GroupProps>, nextState: Readonly<import("@alifd/next/types/checkbox/types").GroupState>, nextContext: any): void;
        }, {}>;
    };
    DatePicker: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/date-picker").DatePickerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        readonly props: Readonly<import("@alifd/next/types/util").RequiredSome<import("@alifd/next/types/date-picker").DatePickerProps, "size" | "rtl" | "format" | "prefix" | "locale" | "onChange" | "defaultVisible" | "onVisibleChange" | "popupAlign" | "disabledDate" | "hasClear" | "popupTriggerType" | "showTime" | "resetTime" | "footerRender" | "onOk">> & Readonly<Pick<{
            prefix: string;
            rtl: boolean;
            format: string;
            size: string;
            showTime: boolean;
            resetTime: boolean;
            disabledDate: () => boolean;
            footerRender: () => null;
            hasClear: boolean;
            popupTriggerType: string;
            popupAlign: string;
            locale: Partial<{
                placeholder: string;
                datetimePlaceholder: string;
                monthPlaceholder: string;
                weekPlaceholder: string;
                yearPlaceholder: string;
                now: string;
                selectTime: string;
                selectDate: string;
                ok: string;
                clear: string;
                startPlaceholder: string;
                endPlaceholder: string;
                hour: string;
                minute: string;
                second: string;
                monthBeforeYear?: boolean | undefined;
            }> & {
                momentLocale?: string | undefined;
            };
            defaultVisible: boolean;
            onChange: () => void;
            onVisibleChange: () => void;
            onOk: () => void;
        }, never>>;
        onValueChange: (newValue: import("moment").Moment | null, handler?: "onChange" | "onOk") => void;
        onSelectCalendarPanel: (value: import("moment").Moment) => void;
        onSelectTimePanel: (value: import("moment").Moment) => void;
        clearValue: () => void;
        onDateInputChange: (inputStr: string | null | undefined, e: import("react").UIEvent<Element, UIEvent>, eventType?: string | undefined) => void;
        onTimeInputChange: (inputStr: string) => void;
        onDateInputBlur: () => void;
        onTimeInputBlur: () => void;
        onKeyDown: (e: import("react").KeyboardEvent<Element>) => void;
        onTimeKeyDown: (e: import("react").KeyboardEvent<Element>) => void;
        handleChange: (newValue: import("moment").Moment | null, prevValue: import("moment").Moment | null, others?: {}) => void;
        onFoucsDateInput: () => void;
        onFoucsTimeInput: () => void;
        onVisibleChange: (visible: boolean, type: string) => void;
        changePanel: (panel: import("@alifd/next/types/date-picker/types").PanelType) => void;
        onOk: (value?: import("moment").Moment | null | undefined) => void;
        renderPreview(others: import("react").HTMLAttributes<HTMLDivElement>): import("react").JSX.Element;
        render(): import("react").JSX.Element;
        context: any;
        setState<K extends keyof import("@alifd/next/types/date-picker/types").DatePickerState>(state: import("@alifd/next/types/date-picker/types").DatePickerState | ((prevState: Readonly<import("@alifd/next/types/date-picker/types").DatePickerState>, props: Readonly<import("@alifd/next/types/date-picker").DatePickerProps>) => import("@alifd/next/types/date-picker/types").DatePickerState | Pick<import("@alifd/next/types/date-picker/types").DatePickerState, K> | null) | Pick<import("@alifd/next/types/date-picker/types").DatePickerState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        state: Readonly<import("@alifd/next/types/date-picker/types").DatePickerState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").DatePickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").DatePickerState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").DatePickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").DatePickerState>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").DatePickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").DatePickerState>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").DatePickerProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").DatePickerProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").DatePickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").DatePickerState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").DatePickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").DatePickerState>, nextContext: any): void;
    }, {}> & {
        RangePicker: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/date-picker").RangePickerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            readonly props: Readonly<import("@alifd/next/types/util").RequiredSome<import("@alifd/next/types/date-picker").RangePickerProps, "size" | "rtl" | "type" | "prefix" | "locale" | "onChange" | "defaultVisible" | "onVisibleChange" | "popupAlign" | "disabledDate" | "disableChangeMode" | "hasClear" | "popupTriggerType" | "showTime" | "resetTime" | "footerRender" | "onOk">> & Readonly<Pick<{
                prefix: string;
                rtl: boolean;
                type: string;
                size: string;
                showTime: boolean;
                resetTime: boolean;
                disabledDate: () => boolean;
                footerRender: () => null;
                hasClear: boolean;
                defaultVisible: boolean;
                popupTriggerType: string;
                popupAlign: string;
                locale: Partial<{
                    placeholder: string;
                    datetimePlaceholder: string;
                    monthPlaceholder: string;
                    weekPlaceholder: string;
                    yearPlaceholder: string;
                    now: string;
                    selectTime: string;
                    selectDate: string;
                    ok: string;
                    clear: string;
                    startPlaceholder: string;
                    endPlaceholder: string;
                    hour: string;
                    minute: string;
                    second: string;
                    monthBeforeYear?: boolean | undefined;
                }> & {
                    momentLocale?: string | undefined;
                };
                disableChangeMode: boolean;
                onChange: () => void;
                onOk: () => void;
                onVisibleChange: () => void;
            }, never>>;
            startDateInputRef: import("react").RefObject<import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">>;
            endDateInputRef: import("react").RefObject<import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">>;
            autoSwitchDateInput: boolean;
            onValueChange: (values: (import("moment").Moment | null | undefined)[], handler?: "onChange" | "onOk") => void;
            onSelectCalendarPanel: (value: import("moment").Moment, active?: "startValue" | "endValue" | "startTime" | "endTime" | undefined) => void;
            clearRange: () => void;
            onDateInputChange: (inputStr: string, e: import("react").SyntheticEvent<Element, Event>, eventType?: string | undefined) => void;
            onDateInputBlur: () => void;
            onDateInputKeyDown: (e: import("react").KeyboardEvent<Element>) => void;
            onFocusDateInput: (type: "startValue" | "endValue" | "startTime" | "endTime" | undefined) => void;
            onFocusTimeInput: (type: "startValue" | "endValue" | "startTime" | "endTime" | undefined) => void;
            onSelectStartTime: (value: import("moment").Moment) => void;
            onSelectEndTime: (value: import("moment").Moment) => void;
            onTimeInputChange: (inputStr: string) => void;
            onTimeInputBlur: () => void;
            onTimeInputKeyDown: (e: import("react").KeyboardEvent<Element>) => void;
            handleChange: (valueName: "startValue" | "endValue", newValue?: import("moment").Moment | null | undefined) => void;
            onVisibleChange: (visible: boolean, type: string) => void;
            changePanel: (panel: import("@alifd/next/types/date-picker/types").PanelType) => void;
            onOk: (value?: (import("moment").Moment | null | undefined)[] | undefined) => void;
            getDisabledTime: ({ startValue, endValue, }: {
                startValue?: import("moment").Moment | null | undefined;
                endValue?: import("moment").Moment | null | undefined;
            } & Record<string, unknown>) => {};
            enableAutoSwitchDateInput: () => void;
            afterOpen: () => void;
            renderPreview([startValue, endValue]: [import("moment").Moment | null, import("moment").Moment | null], others: import("react").HTMLAttributes<HTMLDivElement>): import("react").JSX.Element;
            render(): import("react").JSX.Element;
            context: any;
            setState<K_1 extends keyof import("@alifd/next/types/date-picker/types").RangePickerState>(state: import("@alifd/next/types/date-picker/types").RangePickerState | ((prevState: Readonly<import("@alifd/next/types/date-picker/types").RangePickerState>, props: Readonly<import("@alifd/next/types/date-picker").RangePickerProps>) => import("@alifd/next/types/date-picker/types").RangePickerState | Pick<import("@alifd/next/types/date-picker/types").RangePickerState, K_1> | null) | Pick<import("@alifd/next/types/date-picker/types").RangePickerState, K_1> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            state: Readonly<import("@alifd/next/types/date-picker/types").RangePickerState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").RangePickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").RangePickerState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").RangePickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").RangePickerState>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").RangePickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").RangePickerState>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").RangePickerProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").RangePickerProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").RangePickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").RangePickerState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").RangePickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").RangePickerState>, nextContext: any): void;
        }, {}>;
        MonthPicker: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/date-picker").MonthPickerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            readonly props: Readonly<import("@alifd/next/types/util").RequiredSome<import("@alifd/next/types/date-picker").MonthPickerProps, "size" | "rtl" | "format" | "prefix" | "locale" | "onChange" | "onVisibleChange" | "popupAlign" | "disabledDate" | "hasClear" | "popupTriggerType" | "footerRender">> & Readonly<Pick<{
                prefix: string;
                rtl: boolean;
                format: string;
                size: string;
                disabledDate: () => boolean;
                footerRender: () => null;
                hasClear: boolean;
                popupTriggerType: string;
                popupAlign: string;
                locale: Partial<{
                    placeholder: string;
                    datetimePlaceholder: string;
                    monthPlaceholder: string;
                    weekPlaceholder: string;
                    yearPlaceholder: string;
                    now: string;
                    selectTime: string;
                    selectDate: string;
                    ok: string;
                    clear: string;
                    startPlaceholder: string;
                    endPlaceholder: string;
                    hour: string;
                    minute: string;
                    second: string;
                    monthBeforeYear?: boolean | undefined;
                }> & {
                    momentLocale?: string | undefined;
                };
                onChange: () => void;
                onVisibleChange: () => void;
            }, never>>;
            onValueChange: (newValue: import("moment").Moment | null) => void;
            onSelectCalendarPanel: (value: import("moment").Moment) => void;
            clearValue: () => void;
            onDateInputChange: (inputStr: string, e: import("react").SyntheticEvent<HTMLInputElement, Event>, eventType?: string | undefined) => void;
            onDateInputBlur: () => void;
            onKeyDown: (e: import("react").KeyboardEvent<Element>) => void;
            handleChange: (newValue: import("moment").Moment | null, prevValue: import("moment").Moment | null, others?: {}, callback?: (() => void) | undefined) => void;
            onVisibleChange: (visible: boolean, type: string) => void;
            renderPreview(others: import("react").HTMLAttributes<HTMLDivElement>): import("react").JSX.Element;
            render(): import("react").JSX.Element;
            context: any;
            setState<K_2 extends keyof import("@alifd/next/types/date-picker/types").MonthPickerState>(state: import("@alifd/next/types/date-picker/types").MonthPickerState | ((prevState: Readonly<import("@alifd/next/types/date-picker/types").MonthPickerState>, props: Readonly<import("@alifd/next/types/date-picker").MonthPickerProps>) => import("@alifd/next/types/date-picker/types").MonthPickerState | Pick<import("@alifd/next/types/date-picker/types").MonthPickerState, K_2> | null) | Pick<import("@alifd/next/types/date-picker/types").MonthPickerState, K_2> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            state: Readonly<import("@alifd/next/types/date-picker/types").MonthPickerState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").MonthPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").MonthPickerState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").MonthPickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").MonthPickerState>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").MonthPickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").MonthPickerState>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").MonthPickerProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").MonthPickerProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").MonthPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").MonthPickerState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").MonthPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").MonthPickerState>, nextContext: any): void;
        }, {}>;
        YearPicker: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/date-picker").YearPickerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            readonly props: Readonly<import("@alifd/next/types/util").RequiredSome<import("@alifd/next/types/date-picker").YearPickerProps, "size" | "rtl" | "format" | "prefix" | "locale" | "onChange" | "onVisibleChange" | "popupAlign" | "disabledDate" | "hasClear" | "popupTriggerType" | "footerRender">> & Readonly<Pick<{
                prefix: string;
                rtl: boolean;
                format: string;
                size: string;
                disabledDate: () => boolean;
                footerRender: () => null;
                hasClear: boolean;
                popupTriggerType: string;
                popupAlign: string;
                locale: Partial<{
                    placeholder: string;
                    datetimePlaceholder: string;
                    monthPlaceholder: string;
                    weekPlaceholder: string;
                    yearPlaceholder: string;
                    now: string;
                    selectTime: string;
                    selectDate: string;
                    ok: string;
                    clear: string;
                    startPlaceholder: string;
                    endPlaceholder: string;
                    hour: string;
                    minute: string;
                    second: string;
                    monthBeforeYear?: boolean | undefined;
                }> & {
                    momentLocale?: string | undefined;
                };
                onChange: () => void;
                onVisibleChange: () => void;
            }, never>>;
            onValueChange: (newValue: import("moment").Moment | null) => void;
            onSelectCalendarPanel: (value: import("moment").Moment) => void;
            clearValue: () => void;
            onDateInputChange: (inputStr: string, e: import("react").SyntheticEvent<Element, Event>, eventType?: string | undefined) => void;
            onDateInputBlur: () => void;
            onKeyDown: (e: import("react").KeyboardEvent<Element>) => void;
            handleChange: (newValue: import("moment").Moment | null, prevValue: import("moment").Moment | null, others?: {}, callback?: (() => void) | undefined) => void;
            onVisibleChange: (visible: boolean, reason: string) => void;
            renderPreview(others: import("react").HTMLAttributes<HTMLDivElement>): import("react").JSX.Element;
            render(): import("react").JSX.Element;
            context: any;
            setState<K_3 extends keyof import("@alifd/next/types/date-picker/types").YearPickerState>(state: import("@alifd/next/types/date-picker/types").YearPickerState | ((prevState: Readonly<import("@alifd/next/types/date-picker/types").YearPickerState>, props: Readonly<import("@alifd/next/types/date-picker").YearPickerProps>) => import("@alifd/next/types/date-picker/types").YearPickerState | Pick<import("@alifd/next/types/date-picker/types").YearPickerState, K_3> | null) | Pick<import("@alifd/next/types/date-picker/types").YearPickerState, K_3> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            state: Readonly<import("@alifd/next/types/date-picker/types").YearPickerState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").YearPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").YearPickerState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").YearPickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").YearPickerState>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").YearPickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").YearPickerState>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").YearPickerProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").YearPickerProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").YearPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").YearPickerState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").YearPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").YearPickerState>, nextContext: any): void;
        }, {}>;
        WeekPicker: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/date-picker").WeekPickerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            readonly props: Readonly<import("@alifd/next/types/util").RequiredSome<import("@alifd/next/types/date-picker").WeekPickerProps, "size" | "rtl" | "format" | "prefix" | "locale" | "onChange" | "defaultVisible" | "onVisibleChange" | "popupAlign" | "disabledDate" | "hasClear" | "popupTriggerType" | "footerRender">> & Readonly<Pick<{
                prefix: string;
                rtl: boolean;
                format: string;
                size: string;
                disabledDate: () => boolean;
                footerRender: () => null;
                hasClear: boolean;
                popupTriggerType: string;
                popupAlign: string;
                locale: Partial<{
                    placeholder: string;
                    datetimePlaceholder: string;
                    monthPlaceholder: string;
                    weekPlaceholder: string;
                    yearPlaceholder: string;
                    now: string;
                    selectTime: string;
                    selectDate: string;
                    ok: string;
                    clear: string;
                    startPlaceholder: string;
                    endPlaceholder: string;
                    hour: string;
                    minute: string;
                    second: string;
                    monthBeforeYear?: boolean | undefined;
                }> & {
                    momentLocale?: string | undefined;
                };
                defaultVisible: boolean;
                onChange: () => void;
                onVisibleChange: () => void;
            }, never>>;
            handleChange: (newValue: import("moment").Moment | null, prevValue: import("moment").Moment | null) => void;
            onDateInputChange: (value: import("moment").Moment | null, e: import("react").SyntheticEvent<Element, Event>, eventType: string) => void;
            onKeyDown: (e: import("react").KeyboardEvent<Element>) => void;
            onVisibleChange: (visible: boolean, type: string) => void;
            onSelectCalendarPanel: (value: import("moment").Moment | null) => void;
            renderPreview(others: import("react").HTMLAttributes<HTMLDivElement>): import("react").JSX.Element;
            dateRender: (value: import("moment").Moment) => import("react").ReactNode;
            render(): import("react").JSX.Element;
            context: any;
            setState<K_4 extends keyof import("@alifd/next/types/date-picker/types").WeekPickerState>(state: import("@alifd/next/types/date-picker/types").WeekPickerState | ((prevState: Readonly<import("@alifd/next/types/date-picker/types").WeekPickerState>, props: Readonly<import("@alifd/next/types/date-picker").WeekPickerProps>) => import("@alifd/next/types/date-picker/types").WeekPickerState | Pick<import("@alifd/next/types/date-picker/types").WeekPickerState, K_4> | null) | Pick<import("@alifd/next/types/date-picker/types").WeekPickerState, K_4> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            state: Readonly<import("@alifd/next/types/date-picker/types").WeekPickerState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").WeekPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").WeekPickerState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").WeekPickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").WeekPickerState>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/date-picker").WeekPickerProps>, prevState: Readonly<import("@alifd/next/types/date-picker/types").WeekPickerState>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").WeekPickerProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/date-picker").WeekPickerProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").WeekPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").WeekPickerState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/date-picker").WeekPickerProps>, nextState: Readonly<import("@alifd/next/types/date-picker/types").WeekPickerState>, nextContext: any): void;
        }, {}>;
    };
    Dialog: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/dialog").DialogProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        render(): React.JSX.Element;
    }, {}> & {
        help: (config: import("@alifd/next/types/dialog").ShowConfig) => {
            hide: () => void;
        };
        show: (config: import("@alifd/next/types/dialog").ShowConfig) => {
            hide: () => void;
        };
        warning: (config: import("@alifd/next/types/dialog").ShowConfig) => {
            hide: () => void;
        };
        error: (config: import("@alifd/next/types/dialog").ShowConfig) => {
            hide: () => void;
        };
        alert: (config: import("@alifd/next/types/dialog").ShowConfig) => {
            hide: () => void;
        };
        confirm: (config: import("@alifd/next/types/dialog").ShowConfig) => {
            hide: () => void;
        };
        Inner: typeof import("@alifd/next/types/dialog/inner").default;
        success: (config: import("@alifd/next/types/dialog").ShowConfig) => {
            hide: () => void;
        };
        notice: (config: import("@alifd/next/types/dialog").ShowConfig) => {
            hide: () => void;
        };
        withContext: <P extends import("@alifd/next/types/dialog/show").WithContextDialogProps, C>(WrappedComponent: React.JSXElementConstructor<P> & C) => (props: JSX.LibraryManagedAttributes<C, Omit<P, "contextDialog">>) => React.JSX.Element;
    };
    Dropdown: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/dropdown").DropdownProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/dropdown/dropdown").default, {}>;
    Form: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/form").FormProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/form/form").default, {}> & {
        Item: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/form").ItemProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/form/item").default, {}> & {
            _typeMark: string;
        };
        Error: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/form").ErrorProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            itemRender: (errors: unknown[]) => unknown[] | null;
            render(): import("react").JSX.Element | null;
            context: any;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/form").ErrorProps>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/form").ErrorProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/form").ErrorProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/form").ErrorProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/form").ErrorProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/form").ErrorProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/form").ErrorProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/form").ErrorProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/form").ErrorProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}> & {
            _typeMark: string;
        };
        Submit: typeof import("@alifd/next/types/form/submit").default;
        Reset: typeof import("@alifd/next/types/form/reset").default;
    };
    Icon: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/icon").IconProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/icon/icon").default, {}> & {
        _typeMark: string;
        createFromIconfontCN: typeof import("@alifd/next/types/icon/icon-font").default;
    };
    Input: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">> & {
        TextArea: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/input").TextAreaProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/textarea").default, Pick<import("@alifd/next/types/input/textarea").default, "focus" | "getInputNode">>;
        Group: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/input").GroupProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            render(): import("react").JSX.Element;
            context: any;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/input").GroupProps>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/input").GroupProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/input").GroupProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/input").GroupProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/input").GroupProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/input").GroupProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/input").GroupProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/input").GroupProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/input").GroupProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
        Password: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/input").PasswordProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/password").default, Pick<import("@alifd/next/types/input/password").default, "focus" | "getInputNode">>;
    };
    Loading: any;
    Message: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/message").MessageProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/message").MessageProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        state: {
            visible: boolean | undefined;
        };
        onClose: () => void;
        render(): import("react").JSX.Element | null;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/message").MessageProps>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("@alifd/next/types/message").MessageProps> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/message").MessageProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/message").MessageProps>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/message").MessageProps>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/message").MessageProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/message").MessageProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/message").MessageProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/message").MessageProps>, nextState: Readonly<{}>, nextContext: any): void;
    }>, {}> & {
        help: (config: import("@alifd/next/types/message/types").OpenProps) => void;
        hide: () => void;
        show: (config: import("@alifd/next/types/message/types").OpenProps) => void;
        open: (config: import("@alifd/next/types/message/types").OpenProps) => {
            key: string;
            close: () => void;
        };
        close: (key?: string | undefined) => void;
        warning: (config: import("@alifd/next/types/message/types").OpenProps) => void;
        error: (config: import("@alifd/next/types/message/types").OpenProps) => void;
        config: (config: Partial<{
            top: number;
            maxCount: number;
            duration: number;
        }>) => void;
        loading: (config: import("@alifd/next/types/message/types").OpenProps) => void;
        success: (config: import("@alifd/next/types/message/types").OpenProps) => void;
        notice: (config: import("@alifd/next/types/message/types").OpenProps) => void;
        destory: () => void;
        withContext: <P extends import("@alifd/next/types/message/toast").WithContextMessageProps, C>(WrappedComponent: import("react").JSXElementConstructor<P> & C) => (props: JSX.LibraryManagedAttributes<C, Omit<P, "contextMessage">>) => import("react").JSX.Element;
    };
    Overlay: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/overlay").OverlayProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        overlayRef: InstanceType<{
            new (props: import("@alifd/next/types/overlay/types").OverlayV1Props): {
                lastAlign: string | boolean | undefined;
                timeoutMap: {
                    [key: string]: number;
                };
                _isMounted: boolean;
                _isDestroyed: boolean;
                focusTimeout: number;
                _animation: {
                    off: () => void;
                } | null;
                _containerNode: HTMLElement | undefined;
                _hasFocused: boolean;
                contentRef: import("react").ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                };
                gatewayRef: InstanceType<{
                    new (props: import("@alifd/next/types/overlay").GatewayProps): {
                        child: Element | null | undefined;
                        componentDidMount(): void;
                        componentDidUpdate(): void;
                        updateContainer: () => void;
                        getChildNode(): Element | Text | null;
                        saveChildRef: (ref: HTMLDivElement) => void;
                        render(): import("react").ReactPortal | null;
                        context: any;
                        setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                        forceUpdate(callback?: () => void): void;
                        readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                            children?: import("react").ReactNode | undefined;
                        }>;
                        state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                        refs: {
                            [key: string]: import("react").ReactInstance;
                        };
                        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                        componentWillUnmount?(): void;
                        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                        componentWillMount?(): void;
                        UNSAFE_componentWillMount?(): void;
                        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                    };
                    displayName: string;
                    propTypes: {
                        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                        container: PropTypes.Requireable<any>;
                        target: PropTypes.Requireable<any>;
                    };
                    defaultProps: {
                        container: () => HTMLElement;
                    };
                    contextType?: import("react").Context<any> | undefined;
                }> | null;
                _keydownEvents: {
                    off: () => void;
                } | null;
                _clickEvents: {
                    off: () => void;
                } | null;
                _touchEvents: {
                    off: () => void;
                } | null;
                overlay: InstanceType</*elided*/ any> | null;
                componentDidMount(): void;
                componentDidUpdate(prevProps: import("@alifd/next/types/overlay/types").OverlayV1Props): void;
                componentWillUnmount(): void;
                doAnimation(open: boolean, close: boolean): void;
                getAnimation(props: import("@alifd/next/types/overlay/types").OverlayV1Props): string | boolean | import("@alifd/next/types/overlay/types").AnimationObjectType;
                getAnimationByAlign(align: Array<string> | string | boolean | undefined): {
                    in: string;
                    out: string;
                };
                addAnimationEvents(): void;
                handlePosition(config: {
                    align: Array<string>;
                }): void;
                handleAnimateEnd(id: string): void;
                onEntering(): void;
                onLeaving(): void;
                onEntered(): void;
                onLeaved(): void;
                beforeOpen(): void;
                beforeClose(): void;
                setFocusNode(): void;
                getContent(): React.ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                };
                getContentNode(): HTMLElement | null;
                getWrapperNode(): Element | null;
                addDocumentEvents(): void;
                removeDocumentEvents(): void;
                handleDocumentKeyDown(e: KeyboardEvent): void;
                isInShadowDOM(node: Element | Text): boolean;
                getEventPath(event: Event | {
                    path: string;
                }): string | EventTarget[] | undefined;
                composedPath(el: HTMLElement | null): (Document | Window | HTMLElement)[] | undefined;
                matchInShadowDOM(node: Element | Text, e: Event): boolean;
                handleDocumentClick(e: Event): void;
                handleMaskClick(e: import("react").MouseEvent<Element>): void;
                saveContentRef: (ref: import("react").ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                }) => void;
                saveGatewayRef: (ref: InstanceType<{
                    new (props: import("@alifd/next/types/overlay").GatewayProps): {
                        child: Element | null | undefined;
                        componentDidMount(): void;
                        componentDidUpdate(): void;
                        updateContainer: () => void;
                        getChildNode(): Element | Text | null;
                        saveChildRef: (ref: HTMLDivElement) => void;
                        render(): import("react").ReactPortal | null;
                        context: any;
                        setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                        forceUpdate(callback?: () => void): void;
                        readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                            children?: import("react").ReactNode | undefined;
                        }>;
                        state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                        refs: {
                            [key: string]: import("react").ReactInstance;
                        };
                        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                        componentWillUnmount?(): void;
                        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                        componentWillMount?(): void;
                        UNSAFE_componentWillMount?(): void;
                        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                    };
                    displayName: string;
                    propTypes: {
                        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                        container: PropTypes.Requireable<any>;
                        target: PropTypes.Requireable<any>;
                    };
                    defaultProps: {
                        container: () => HTMLElement;
                    };
                    contextType?: import("react").Context<any> | undefined;
                }> | null) => void;
                getInstance(): /*elided*/ any;
                render(): React.JSX.Element;
                context: any;
                setState<K extends keyof import("@alifd/next/types/overlay/types").OverlayState>(state: import("@alifd/next/types/overlay/types").OverlayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>) => import("@alifd/next/types/overlay/types").OverlayState | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>) | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>, callback?: () => void): void;
                forceUpdate(callback?: () => void): void;
                readonly props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props> & Readonly<{
                    children?: import("react").ReactNode | undefined;
                }>;
                state: Readonly<import("@alifd/next/types/overlay/types").OverlayState>;
                refs: {
                    [key: string]: import("react").ReactInstance;
                };
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): boolean;
                componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>): any;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
            };
            propTypes: {
                prefix: PropTypes.Requireable<string>;
                pure: PropTypes.Requireable<boolean>;
                rtl: PropTypes.Requireable<boolean>;
                className: PropTypes.Requireable<string>;
                style: PropTypes.Requireable<object>;
                children: PropTypes.Requireable<any>;
                visible: PropTypes.Requireable<boolean>;
                onRequestClose: PropTypes.Requireable<(...args: any[]) => any>;
                target: PropTypes.Requireable<any>;
                align: PropTypes.Requireable<string>;
                offset: PropTypes.Requireable<any[]>;
                container: PropTypes.Requireable<any>;
                hasMask: PropTypes.Requireable<boolean>;
                canCloseByEsc: PropTypes.Requireable<boolean>;
                canCloseByOutSideClick: PropTypes.Requireable<boolean>;
                canCloseByMask: PropTypes.Requireable<boolean>;
                beforeOpen: PropTypes.Requireable<(...args: any[]) => any>;
                onOpen: PropTypes.Requireable<(...args: any[]) => any>;
                afterOpen: PropTypes.Requireable<(...args: any[]) => any>;
                beforeClose: PropTypes.Requireable<(...args: any[]) => any>;
                onClose: PropTypes.Requireable<(...args: any[]) => any>;
                afterClose: PropTypes.Requireable<(...args: any[]) => any>;
                beforePosition: PropTypes.Requireable<(...args: any[]) => any>;
                onPosition: PropTypes.Requireable<(...args: any[]) => any>;
                shouldUpdatePosition: PropTypes.Requireable<boolean>;
                autoFocus: PropTypes.Requireable<boolean>;
                needAdjust: PropTypes.Requireable<boolean>;
                disableScroll: PropTypes.Requireable<boolean>;
                useCapture: PropTypes.Requireable<boolean>;
                cache: PropTypes.Requireable<boolean>;
                safeNode: PropTypes.Requireable<any>;
                wrapperClassName: PropTypes.Requireable<string>;
                wrapperStyle: PropTypes.Requireable<object>;
                animation: PropTypes.Requireable<NonNullable<boolean | object>>;
                onMaskMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
                onMaskMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
                onClick: PropTypes.Requireable<(...args: any[]) => any>;
                maskClass: PropTypes.Requireable<string>;
                isChildrenInMask: PropTypes.Requireable<boolean>;
                pinFollowBaseElementWhenFixed: PropTypes.Requireable<boolean>;
                v2: PropTypes.Requireable<boolean>;
                points: PropTypes.Requireable<any[]>;
            };
            defaultProps: {
                prefix: string;
                pure: boolean;
                visible: boolean;
                onRequestClose: () => void;
                target: "viewport";
                align: string;
                offset: number[];
                hasMask: boolean;
                canCloseByEsc: boolean;
                canCloseByOutSideClick: boolean;
                canCloseByMask: boolean;
                beforeOpen: () => void;
                onOpen: () => void;
                afterOpen: () => void;
                beforeClose: () => void;
                onClose: () => void;
                afterClose: () => void;
                beforePosition: () => void;
                onPosition: () => void;
                onMaskMouseEnter: () => void;
                onMaskMouseLeave: () => void;
                shouldUpdatePosition: boolean;
                autoFocus: boolean;
                needAdjust: boolean;
                disableScroll: boolean;
                cache: boolean;
                isChildrenInMask: boolean;
                onTouchEnd: (event: import("react").UIEvent) => void;
                onClick: (event: import("react").UIEvent) => void;
                maskClass: string;
                useCapture: boolean;
            };
            displayName: string;
            getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay/types").OverlayV1Props, prevState: import("@alifd/next/types/overlay/types").OverlayState): Partial<import("@alifd/next/types/overlay/types").OverlayState>;
            contextType?: import("react").Context<any> | undefined;
        }> | null;
        saveRef(ref: InstanceType<{
            new (props: import("@alifd/next/types/overlay/types").OverlayV1Props): {
                lastAlign: string | boolean | undefined;
                timeoutMap: {
                    [key: string]: number;
                };
                _isMounted: boolean;
                _isDestroyed: boolean;
                focusTimeout: number;
                _animation: {
                    off: () => void;
                } | null;
                _containerNode: HTMLElement | undefined;
                _hasFocused: boolean;
                contentRef: import("react").ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                };
                gatewayRef: InstanceType<{
                    new (props: import("@alifd/next/types/overlay").GatewayProps): {
                        child: Element | null | undefined;
                        componentDidMount(): void;
                        componentDidUpdate(): void;
                        updateContainer: () => void;
                        getChildNode(): Element | Text | null;
                        saveChildRef: (ref: HTMLDivElement) => void;
                        render(): import("react").ReactPortal | null;
                        context: any;
                        setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                        forceUpdate(callback?: () => void): void;
                        readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                            children?: import("react").ReactNode | undefined;
                        }>;
                        state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                        refs: {
                            [key: string]: import("react").ReactInstance;
                        };
                        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                        componentWillUnmount?(): void;
                        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                        componentWillMount?(): void;
                        UNSAFE_componentWillMount?(): void;
                        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                    };
                    displayName: string;
                    propTypes: {
                        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                        container: PropTypes.Requireable<any>;
                        target: PropTypes.Requireable<any>;
                    };
                    defaultProps: {
                        container: () => HTMLElement;
                    };
                    contextType?: import("react").Context<any> | undefined;
                }> | null;
                _keydownEvents: {
                    off: () => void;
                } | null;
                _clickEvents: {
                    off: () => void;
                } | null;
                _touchEvents: {
                    off: () => void;
                } | null;
                overlay: InstanceType</*elided*/ any> | null;
                componentDidMount(): void;
                componentDidUpdate(prevProps: import("@alifd/next/types/overlay/types").OverlayV1Props): void;
                componentWillUnmount(): void;
                doAnimation(open: boolean, close: boolean): void;
                getAnimation(props: import("@alifd/next/types/overlay/types").OverlayV1Props): string | boolean | import("@alifd/next/types/overlay/types").AnimationObjectType;
                getAnimationByAlign(align: Array<string> | string | boolean | undefined): {
                    in: string;
                    out: string;
                };
                addAnimationEvents(): void;
                handlePosition(config: {
                    align: Array<string>;
                }): void;
                handleAnimateEnd(id: string): void;
                onEntering(): void;
                onLeaving(): void;
                onEntered(): void;
                onLeaved(): void;
                beforeOpen(): void;
                beforeClose(): void;
                setFocusNode(): void;
                getContent(): React.ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                };
                getContentNode(): HTMLElement | null;
                getWrapperNode(): Element | null;
                addDocumentEvents(): void;
                removeDocumentEvents(): void;
                handleDocumentKeyDown(e: KeyboardEvent): void;
                isInShadowDOM(node: Element | Text): boolean;
                getEventPath(event: Event | {
                    path: string;
                }): string | EventTarget[] | undefined;
                composedPath(el: HTMLElement | null): (Document | Window | HTMLElement)[] | undefined;
                matchInShadowDOM(node: Element | Text, e: Event): boolean;
                handleDocumentClick(e: Event): void;
                handleMaskClick(e: import("react").MouseEvent<Element>): void;
                saveContentRef: (ref: import("react").ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                }) => void;
                saveGatewayRef: (ref: InstanceType<{
                    new (props: import("@alifd/next/types/overlay").GatewayProps): {
                        child: Element | null | undefined;
                        componentDidMount(): void;
                        componentDidUpdate(): void;
                        updateContainer: () => void;
                        getChildNode(): Element | Text | null;
                        saveChildRef: (ref: HTMLDivElement) => void;
                        render(): import("react").ReactPortal | null;
                        context: any;
                        setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                        forceUpdate(callback?: () => void): void;
                        readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                            children?: import("react").ReactNode | undefined;
                        }>;
                        state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                        refs: {
                            [key: string]: import("react").ReactInstance;
                        };
                        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                        componentWillUnmount?(): void;
                        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                        componentWillMount?(): void;
                        UNSAFE_componentWillMount?(): void;
                        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                    };
                    displayName: string;
                    propTypes: {
                        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                        container: PropTypes.Requireable<any>;
                        target: PropTypes.Requireable<any>;
                    };
                    defaultProps: {
                        container: () => HTMLElement;
                    };
                    contextType?: import("react").Context<any> | undefined;
                }> | null) => void;
                getInstance(): /*elided*/ any;
                render(): React.JSX.Element;
                context: any;
                setState<K extends keyof import("@alifd/next/types/overlay/types").OverlayState>(state: import("@alifd/next/types/overlay/types").OverlayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>) => import("@alifd/next/types/overlay/types").OverlayState | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>) | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>, callback?: () => void): void;
                forceUpdate(callback?: () => void): void;
                readonly props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props> & Readonly<{
                    children?: import("react").ReactNode | undefined;
                }>;
                state: Readonly<import("@alifd/next/types/overlay/types").OverlayState>;
                refs: {
                    [key: string]: import("react").ReactInstance;
                };
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): boolean;
                componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>): any;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
            };
            propTypes: {
                prefix: PropTypes.Requireable<string>;
                pure: PropTypes.Requireable<boolean>;
                rtl: PropTypes.Requireable<boolean>;
                className: PropTypes.Requireable<string>;
                style: PropTypes.Requireable<object>;
                children: PropTypes.Requireable<any>;
                visible: PropTypes.Requireable<boolean>;
                onRequestClose: PropTypes.Requireable<(...args: any[]) => any>;
                target: PropTypes.Requireable<any>;
                align: PropTypes.Requireable<string>;
                offset: PropTypes.Requireable<any[]>;
                container: PropTypes.Requireable<any>;
                hasMask: PropTypes.Requireable<boolean>;
                canCloseByEsc: PropTypes.Requireable<boolean>;
                canCloseByOutSideClick: PropTypes.Requireable<boolean>;
                canCloseByMask: PropTypes.Requireable<boolean>;
                beforeOpen: PropTypes.Requireable<(...args: any[]) => any>;
                onOpen: PropTypes.Requireable<(...args: any[]) => any>;
                afterOpen: PropTypes.Requireable<(...args: any[]) => any>;
                beforeClose: PropTypes.Requireable<(...args: any[]) => any>;
                onClose: PropTypes.Requireable<(...args: any[]) => any>;
                afterClose: PropTypes.Requireable<(...args: any[]) => any>;
                beforePosition: PropTypes.Requireable<(...args: any[]) => any>;
                onPosition: PropTypes.Requireable<(...args: any[]) => any>;
                shouldUpdatePosition: PropTypes.Requireable<boolean>;
                autoFocus: PropTypes.Requireable<boolean>;
                needAdjust: PropTypes.Requireable<boolean>;
                disableScroll: PropTypes.Requireable<boolean>;
                useCapture: PropTypes.Requireable<boolean>;
                cache: PropTypes.Requireable<boolean>;
                safeNode: PropTypes.Requireable<any>;
                wrapperClassName: PropTypes.Requireable<string>;
                wrapperStyle: PropTypes.Requireable<object>;
                animation: PropTypes.Requireable<NonNullable<boolean | object>>;
                onMaskMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
                onMaskMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
                onClick: PropTypes.Requireable<(...args: any[]) => any>;
                maskClass: PropTypes.Requireable<string>;
                isChildrenInMask: PropTypes.Requireable<boolean>;
                pinFollowBaseElementWhenFixed: PropTypes.Requireable<boolean>;
                v2: PropTypes.Requireable<boolean>;
                points: PropTypes.Requireable<any[]>;
            };
            defaultProps: {
                prefix: string;
                pure: boolean;
                visible: boolean;
                onRequestClose: () => void;
                target: "viewport";
                align: string;
                offset: number[];
                hasMask: boolean;
                canCloseByEsc: boolean;
                canCloseByOutSideClick: boolean;
                canCloseByMask: boolean;
                beforeOpen: () => void;
                onOpen: () => void;
                afterOpen: () => void;
                beforeClose: () => void;
                onClose: () => void;
                afterClose: () => void;
                beforePosition: () => void;
                onPosition: () => void;
                onMaskMouseEnter: () => void;
                onMaskMouseLeave: () => void;
                shouldUpdatePosition: boolean;
                autoFocus: boolean;
                needAdjust: boolean;
                disableScroll: boolean;
                cache: boolean;
                isChildrenInMask: boolean;
                onTouchEnd: (event: import("react").UIEvent) => void;
                onClick: (event: import("react").UIEvent) => void;
                maskClass: string;
                useCapture: boolean;
            };
            displayName: string;
            getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay/types").OverlayV1Props, prevState: import("@alifd/next/types/overlay/types").OverlayState): Partial<import("@alifd/next/types/overlay/types").OverlayState>;
            contextType?: import("react").Context<any> | undefined;
        }> | null): void;
        getContent(): (React.ReactInstance & {
            headerNode: HTMLElement;
            bodyNode: HTMLElement;
            footerNode: HTMLDivElement;
        }) | null;
        getContentNode(): HTMLElement | null;
        render(): React.JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/overlay").OverlayProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<import("@alifd/next/types/overlay").OverlayProps> & Readonly<{
            children?: import("react").ReactNode | undefined;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextState: Readonly<{}>, nextContext: any): void;
    }, Pick<{
        overlayRef: InstanceType<{
            new (props: import("@alifd/next/types/overlay/types").OverlayV1Props): {
                lastAlign: string | boolean | undefined;
                timeoutMap: {
                    [key: string]: number;
                };
                _isMounted: boolean;
                _isDestroyed: boolean;
                focusTimeout: number;
                _animation: {
                    off: () => void;
                } | null;
                _containerNode: HTMLElement | undefined;
                _hasFocused: boolean;
                contentRef: import("react").ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                };
                gatewayRef: InstanceType<{
                    new (props: import("@alifd/next/types/overlay").GatewayProps): {
                        child: Element | null | undefined;
                        componentDidMount(): void;
                        componentDidUpdate(): void;
                        updateContainer: () => void;
                        getChildNode(): Element | Text | null;
                        saveChildRef: (ref: HTMLDivElement) => void;
                        render(): import("react").ReactPortal | null;
                        context: any;
                        setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                        forceUpdate(callback?: () => void): void;
                        readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                            children?: import("react").ReactNode | undefined;
                        }>;
                        state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                        refs: {
                            [key: string]: import("react").ReactInstance;
                        };
                        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                        componentWillUnmount?(): void;
                        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                        componentWillMount?(): void;
                        UNSAFE_componentWillMount?(): void;
                        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                    };
                    displayName: string;
                    propTypes: {
                        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                        container: PropTypes.Requireable<any>;
                        target: PropTypes.Requireable<any>;
                    };
                    defaultProps: {
                        container: () => HTMLElement;
                    };
                    contextType?: import("react").Context<any> | undefined;
                }> | null;
                _keydownEvents: {
                    off: () => void;
                } | null;
                _clickEvents: {
                    off: () => void;
                } | null;
                _touchEvents: {
                    off: () => void;
                } | null;
                overlay: InstanceType</*elided*/ any> | null;
                componentDidMount(): void;
                componentDidUpdate(prevProps: import("@alifd/next/types/overlay/types").OverlayV1Props): void;
                componentWillUnmount(): void;
                doAnimation(open: boolean, close: boolean): void;
                getAnimation(props: import("@alifd/next/types/overlay/types").OverlayV1Props): string | boolean | import("@alifd/next/types/overlay/types").AnimationObjectType;
                getAnimationByAlign(align: Array<string> | string | boolean | undefined): {
                    in: string;
                    out: string;
                };
                addAnimationEvents(): void;
                handlePosition(config: {
                    align: Array<string>;
                }): void;
                handleAnimateEnd(id: string): void;
                onEntering(): void;
                onLeaving(): void;
                onEntered(): void;
                onLeaved(): void;
                beforeOpen(): void;
                beforeClose(): void;
                setFocusNode(): void;
                getContent(): React.ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                };
                getContentNode(): HTMLElement | null;
                getWrapperNode(): Element | null;
                addDocumentEvents(): void;
                removeDocumentEvents(): void;
                handleDocumentKeyDown(e: KeyboardEvent): void;
                isInShadowDOM(node: Element | Text): boolean;
                getEventPath(event: Event | {
                    path: string;
                }): string | EventTarget[] | undefined;
                composedPath(el: HTMLElement | null): (Document | Window | HTMLElement)[] | undefined;
                matchInShadowDOM(node: Element | Text, e: Event): boolean;
                handleDocumentClick(e: Event): void;
                handleMaskClick(e: import("react").MouseEvent<Element>): void;
                saveContentRef: (ref: import("react").ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                }) => void;
                saveGatewayRef: (ref: InstanceType<{
                    new (props: import("@alifd/next/types/overlay").GatewayProps): {
                        child: Element | null | undefined;
                        componentDidMount(): void;
                        componentDidUpdate(): void;
                        updateContainer: () => void;
                        getChildNode(): Element | Text | null;
                        saveChildRef: (ref: HTMLDivElement) => void;
                        render(): import("react").ReactPortal | null;
                        context: any;
                        setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                        forceUpdate(callback?: () => void): void;
                        readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                            children?: import("react").ReactNode | undefined;
                        }>;
                        state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                        refs: {
                            [key: string]: import("react").ReactInstance;
                        };
                        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                        componentWillUnmount?(): void;
                        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                        componentWillMount?(): void;
                        UNSAFE_componentWillMount?(): void;
                        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                    };
                    displayName: string;
                    propTypes: {
                        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                        container: PropTypes.Requireable<any>;
                        target: PropTypes.Requireable<any>;
                    };
                    defaultProps: {
                        container: () => HTMLElement;
                    };
                    contextType?: import("react").Context<any> | undefined;
                }> | null) => void;
                getInstance(): /*elided*/ any;
                render(): React.JSX.Element;
                context: any;
                setState<K extends keyof import("@alifd/next/types/overlay/types").OverlayState>(state: import("@alifd/next/types/overlay/types").OverlayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>) => import("@alifd/next/types/overlay/types").OverlayState | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>) | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>, callback?: () => void): void;
                forceUpdate(callback?: () => void): void;
                readonly props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props> & Readonly<{
                    children?: import("react").ReactNode | undefined;
                }>;
                state: Readonly<import("@alifd/next/types/overlay/types").OverlayState>;
                refs: {
                    [key: string]: import("react").ReactInstance;
                };
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): boolean;
                componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>): any;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
            };
            propTypes: {
                prefix: PropTypes.Requireable<string>;
                pure: PropTypes.Requireable<boolean>;
                rtl: PropTypes.Requireable<boolean>;
                className: PropTypes.Requireable<string>;
                style: PropTypes.Requireable<object>;
                children: PropTypes.Requireable<any>;
                visible: PropTypes.Requireable<boolean>;
                onRequestClose: PropTypes.Requireable<(...args: any[]) => any>;
                target: PropTypes.Requireable<any>;
                align: PropTypes.Requireable<string>;
                offset: PropTypes.Requireable<any[]>;
                container: PropTypes.Requireable<any>;
                hasMask: PropTypes.Requireable<boolean>;
                canCloseByEsc: PropTypes.Requireable<boolean>;
                canCloseByOutSideClick: PropTypes.Requireable<boolean>;
                canCloseByMask: PropTypes.Requireable<boolean>;
                beforeOpen: PropTypes.Requireable<(...args: any[]) => any>;
                onOpen: PropTypes.Requireable<(...args: any[]) => any>;
                afterOpen: PropTypes.Requireable<(...args: any[]) => any>;
                beforeClose: PropTypes.Requireable<(...args: any[]) => any>;
                onClose: PropTypes.Requireable<(...args: any[]) => any>;
                afterClose: PropTypes.Requireable<(...args: any[]) => any>;
                beforePosition: PropTypes.Requireable<(...args: any[]) => any>;
                onPosition: PropTypes.Requireable<(...args: any[]) => any>;
                shouldUpdatePosition: PropTypes.Requireable<boolean>;
                autoFocus: PropTypes.Requireable<boolean>;
                needAdjust: PropTypes.Requireable<boolean>;
                disableScroll: PropTypes.Requireable<boolean>;
                useCapture: PropTypes.Requireable<boolean>;
                cache: PropTypes.Requireable<boolean>;
                safeNode: PropTypes.Requireable<any>;
                wrapperClassName: PropTypes.Requireable<string>;
                wrapperStyle: PropTypes.Requireable<object>;
                animation: PropTypes.Requireable<NonNullable<boolean | object>>;
                onMaskMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
                onMaskMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
                onClick: PropTypes.Requireable<(...args: any[]) => any>;
                maskClass: PropTypes.Requireable<string>;
                isChildrenInMask: PropTypes.Requireable<boolean>;
                pinFollowBaseElementWhenFixed: PropTypes.Requireable<boolean>;
                v2: PropTypes.Requireable<boolean>;
                points: PropTypes.Requireable<any[]>;
            };
            defaultProps: {
                prefix: string;
                pure: boolean;
                visible: boolean;
                onRequestClose: () => void;
                target: "viewport";
                align: string;
                offset: number[];
                hasMask: boolean;
                canCloseByEsc: boolean;
                canCloseByOutSideClick: boolean;
                canCloseByMask: boolean;
                beforeOpen: () => void;
                onOpen: () => void;
                afterOpen: () => void;
                beforeClose: () => void;
                onClose: () => void;
                afterClose: () => void;
                beforePosition: () => void;
                onPosition: () => void;
                onMaskMouseEnter: () => void;
                onMaskMouseLeave: () => void;
                shouldUpdatePosition: boolean;
                autoFocus: boolean;
                needAdjust: boolean;
                disableScroll: boolean;
                cache: boolean;
                isChildrenInMask: boolean;
                onTouchEnd: (event: import("react").UIEvent) => void;
                onClick: (event: import("react").UIEvent) => void;
                maskClass: string;
                useCapture: boolean;
            };
            displayName: string;
            getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay/types").OverlayV1Props, prevState: import("@alifd/next/types/overlay/types").OverlayState): Partial<import("@alifd/next/types/overlay/types").OverlayState>;
            contextType?: import("react").Context<any> | undefined;
        }> | null;
        saveRef(ref: InstanceType<{
            new (props: import("@alifd/next/types/overlay/types").OverlayV1Props): {
                lastAlign: string | boolean | undefined;
                timeoutMap: {
                    [key: string]: number;
                };
                _isMounted: boolean;
                _isDestroyed: boolean;
                focusTimeout: number;
                _animation: {
                    off: () => void;
                } | null;
                _containerNode: HTMLElement | undefined;
                _hasFocused: boolean;
                contentRef: import("react").ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                };
                gatewayRef: InstanceType<{
                    new (props: import("@alifd/next/types/overlay").GatewayProps): {
                        child: Element | null | undefined;
                        componentDidMount(): void;
                        componentDidUpdate(): void;
                        updateContainer: () => void;
                        getChildNode(): Element | Text | null;
                        saveChildRef: (ref: HTMLDivElement) => void;
                        render(): import("react").ReactPortal | null;
                        context: any;
                        setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                        forceUpdate(callback?: () => void): void;
                        readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                            children?: import("react").ReactNode | undefined;
                        }>;
                        state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                        refs: {
                            [key: string]: import("react").ReactInstance;
                        };
                        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                        componentWillUnmount?(): void;
                        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                        componentWillMount?(): void;
                        UNSAFE_componentWillMount?(): void;
                        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                    };
                    displayName: string;
                    propTypes: {
                        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                        container: PropTypes.Requireable<any>;
                        target: PropTypes.Requireable<any>;
                    };
                    defaultProps: {
                        container: () => HTMLElement;
                    };
                    contextType?: import("react").Context<any> | undefined;
                }> | null;
                _keydownEvents: {
                    off: () => void;
                } | null;
                _clickEvents: {
                    off: () => void;
                } | null;
                _touchEvents: {
                    off: () => void;
                } | null;
                overlay: InstanceType</*elided*/ any> | null;
                componentDidMount(): void;
                componentDidUpdate(prevProps: import("@alifd/next/types/overlay/types").OverlayV1Props): void;
                componentWillUnmount(): void;
                doAnimation(open: boolean, close: boolean): void;
                getAnimation(props: import("@alifd/next/types/overlay/types").OverlayV1Props): string | boolean | import("@alifd/next/types/overlay/types").AnimationObjectType;
                getAnimationByAlign(align: Array<string> | string | boolean | undefined): {
                    in: string;
                    out: string;
                };
                addAnimationEvents(): void;
                handlePosition(config: {
                    align: Array<string>;
                }): void;
                handleAnimateEnd(id: string): void;
                onEntering(): void;
                onLeaving(): void;
                onEntered(): void;
                onLeaved(): void;
                beforeOpen(): void;
                beforeClose(): void;
                setFocusNode(): void;
                getContent(): React.ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                };
                getContentNode(): HTMLElement | null;
                getWrapperNode(): Element | null;
                addDocumentEvents(): void;
                removeDocumentEvents(): void;
                handleDocumentKeyDown(e: KeyboardEvent): void;
                isInShadowDOM(node: Element | Text): boolean;
                getEventPath(event: Event | {
                    path: string;
                }): string | EventTarget[] | undefined;
                composedPath(el: HTMLElement | null): (Document | Window | HTMLElement)[] | undefined;
                matchInShadowDOM(node: Element | Text, e: Event): boolean;
                handleDocumentClick(e: Event): void;
                handleMaskClick(e: import("react").MouseEvent<Element>): void;
                saveContentRef: (ref: import("react").ReactInstance & {
                    headerNode: HTMLElement;
                    bodyNode: HTMLElement;
                    footerNode: HTMLDivElement;
                }) => void;
                saveGatewayRef: (ref: InstanceType<{
                    new (props: import("@alifd/next/types/overlay").GatewayProps): {
                        child: Element | null | undefined;
                        componentDidMount(): void;
                        componentDidUpdate(): void;
                        updateContainer: () => void;
                        getChildNode(): Element | Text | null;
                        saveChildRef: (ref: HTMLDivElement) => void;
                        render(): import("react").ReactPortal | null;
                        context: any;
                        setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                        forceUpdate(callback?: () => void): void;
                        readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                            children?: import("react").ReactNode | undefined;
                        }>;
                        state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                        refs: {
                            [key: string]: import("react").ReactInstance;
                        };
                        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                        componentWillUnmount?(): void;
                        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                        componentWillMount?(): void;
                        UNSAFE_componentWillMount?(): void;
                        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                    };
                    displayName: string;
                    propTypes: {
                        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                        container: PropTypes.Requireable<any>;
                        target: PropTypes.Requireable<any>;
                    };
                    defaultProps: {
                        container: () => HTMLElement;
                    };
                    contextType?: import("react").Context<any> | undefined;
                }> | null) => void;
                getInstance(): /*elided*/ any;
                render(): React.JSX.Element;
                context: any;
                setState<K extends keyof import("@alifd/next/types/overlay/types").OverlayState>(state: import("@alifd/next/types/overlay/types").OverlayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>) => import("@alifd/next/types/overlay/types").OverlayState | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>) | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>, callback?: () => void): void;
                forceUpdate(callback?: () => void): void;
                readonly props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props> & Readonly<{
                    children?: import("react").ReactNode | undefined;
                }>;
                state: Readonly<import("@alifd/next/types/overlay/types").OverlayState>;
                refs: {
                    [key: string]: import("react").ReactInstance;
                };
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): boolean;
                componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>): any;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
            };
            propTypes: {
                prefix: PropTypes.Requireable<string>;
                pure: PropTypes.Requireable<boolean>;
                rtl: PropTypes.Requireable<boolean>;
                className: PropTypes.Requireable<string>;
                style: PropTypes.Requireable<object>;
                children: PropTypes.Requireable<any>;
                visible: PropTypes.Requireable<boolean>;
                onRequestClose: PropTypes.Requireable<(...args: any[]) => any>;
                target: PropTypes.Requireable<any>;
                align: PropTypes.Requireable<string>;
                offset: PropTypes.Requireable<any[]>;
                container: PropTypes.Requireable<any>;
                hasMask: PropTypes.Requireable<boolean>;
                canCloseByEsc: PropTypes.Requireable<boolean>;
                canCloseByOutSideClick: PropTypes.Requireable<boolean>;
                canCloseByMask: PropTypes.Requireable<boolean>;
                beforeOpen: PropTypes.Requireable<(...args: any[]) => any>;
                onOpen: PropTypes.Requireable<(...args: any[]) => any>;
                afterOpen: PropTypes.Requireable<(...args: any[]) => any>;
                beforeClose: PropTypes.Requireable<(...args: any[]) => any>;
                onClose: PropTypes.Requireable<(...args: any[]) => any>;
                afterClose: PropTypes.Requireable<(...args: any[]) => any>;
                beforePosition: PropTypes.Requireable<(...args: any[]) => any>;
                onPosition: PropTypes.Requireable<(...args: any[]) => any>;
                shouldUpdatePosition: PropTypes.Requireable<boolean>;
                autoFocus: PropTypes.Requireable<boolean>;
                needAdjust: PropTypes.Requireable<boolean>;
                disableScroll: PropTypes.Requireable<boolean>;
                useCapture: PropTypes.Requireable<boolean>;
                cache: PropTypes.Requireable<boolean>;
                safeNode: PropTypes.Requireable<any>;
                wrapperClassName: PropTypes.Requireable<string>;
                wrapperStyle: PropTypes.Requireable<object>;
                animation: PropTypes.Requireable<NonNullable<boolean | object>>;
                onMaskMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
                onMaskMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
                onClick: PropTypes.Requireable<(...args: any[]) => any>;
                maskClass: PropTypes.Requireable<string>;
                isChildrenInMask: PropTypes.Requireable<boolean>;
                pinFollowBaseElementWhenFixed: PropTypes.Requireable<boolean>;
                v2: PropTypes.Requireable<boolean>;
                points: PropTypes.Requireable<any[]>;
            };
            defaultProps: {
                prefix: string;
                pure: boolean;
                visible: boolean;
                onRequestClose: () => void;
                target: "viewport";
                align: string;
                offset: number[];
                hasMask: boolean;
                canCloseByEsc: boolean;
                canCloseByOutSideClick: boolean;
                canCloseByMask: boolean;
                beforeOpen: () => void;
                onOpen: () => void;
                afterOpen: () => void;
                beforeClose: () => void;
                onClose: () => void;
                afterClose: () => void;
                beforePosition: () => void;
                onPosition: () => void;
                onMaskMouseEnter: () => void;
                onMaskMouseLeave: () => void;
                shouldUpdatePosition: boolean;
                autoFocus: boolean;
                needAdjust: boolean;
                disableScroll: boolean;
                cache: boolean;
                isChildrenInMask: boolean;
                onTouchEnd: (event: import("react").UIEvent) => void;
                onClick: (event: import("react").UIEvent) => void;
                maskClass: string;
                useCapture: boolean;
            };
            displayName: string;
            getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay/types").OverlayV1Props, prevState: import("@alifd/next/types/overlay/types").OverlayState): Partial<import("@alifd/next/types/overlay/types").OverlayState>;
            contextType?: import("react").Context<any> | undefined;
        }> | null): void;
        getContent(): (React.ReactInstance & {
            headerNode: HTMLElement;
            bodyNode: HTMLElement;
            footerNode: HTMLDivElement;
        }) | null;
        getContentNode(): HTMLElement | null;
        render(): React.JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/overlay").OverlayProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<import("@alifd/next/types/overlay").OverlayProps> & Readonly<{
            children?: import("react").ReactNode | undefined;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").OverlayProps>, nextState: Readonly<{}>, nextContext: any): void;
    }, "getContent" | "getContentNode">> & {
        Popup: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/overlay").PopupProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            overlay: InstanceType<{
                new (props: import("@alifd/next/types/overlay/types").OverlayV1Props): {
                    lastAlign: string | boolean | undefined;
                    timeoutMap: {
                        [key: string]: number;
                    };
                    _isMounted: boolean;
                    _isDestroyed: boolean;
                    focusTimeout: number;
                    _animation: {
                        off: () => void;
                    } | null;
                    _containerNode: HTMLElement | undefined;
                    _hasFocused: boolean;
                    contentRef: import("react").ReactInstance & {
                        headerNode: HTMLElement;
                        bodyNode: HTMLElement;
                        footerNode: HTMLDivElement;
                    };
                    gatewayRef: InstanceType<{
                        new (props: import("@alifd/next/types/overlay").GatewayProps): {
                            child: Element | null | undefined;
                            componentDidMount(): void;
                            componentDidUpdate(): void;
                            updateContainer: () => void;
                            getChildNode(): Element | Text | null;
                            saveChildRef: (ref: HTMLDivElement) => void;
                            render(): import("react").ReactPortal | null;
                            context: any;
                            setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                            forceUpdate(callback?: () => void): void;
                            readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                                children?: import("react").ReactNode | undefined;
                            }>;
                            state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                            refs: {
                                [key: string]: import("react").ReactInstance;
                            };
                            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                            componentWillUnmount?(): void;
                            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                            componentWillMount?(): void;
                            UNSAFE_componentWillMount?(): void;
                            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        };
                        displayName: string;
                        propTypes: {
                            children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                            container: PropTypes.Requireable<any>;
                            target: PropTypes.Requireable<any>;
                        };
                        defaultProps: {
                            container: () => HTMLElement;
                        };
                        contextType?: import("react").Context<any> | undefined;
                    }> | null;
                    _keydownEvents: {
                        off: () => void;
                    } | null;
                    _clickEvents: {
                        off: () => void;
                    } | null;
                    _touchEvents: {
                        off: () => void;
                    } | null;
                    overlay: InstanceType</*elided*/ any> | null;
                    componentDidMount(): void;
                    componentDidUpdate(prevProps: import("@alifd/next/types/overlay/types").OverlayV1Props): void;
                    componentWillUnmount(): void;
                    doAnimation(open: boolean, close: boolean): void;
                    getAnimation(props: import("@alifd/next/types/overlay/types").OverlayV1Props): string | boolean | import("@alifd/next/types/overlay/types").AnimationObjectType;
                    getAnimationByAlign(align: Array<string> | string | boolean | undefined): {
                        in: string;
                        out: string;
                    };
                    addAnimationEvents(): void;
                    handlePosition(config: {
                        align: Array<string>;
                    }): void;
                    handleAnimateEnd(id: string): void;
                    onEntering(): void;
                    onLeaving(): void;
                    onEntered(): void;
                    onLeaved(): void;
                    beforeOpen(): void;
                    beforeClose(): void;
                    setFocusNode(): void;
                    getContent(): React.ReactInstance & {
                        headerNode: HTMLElement;
                        bodyNode: HTMLElement;
                        footerNode: HTMLDivElement;
                    };
                    getContentNode(): HTMLElement | null;
                    getWrapperNode(): Element | null;
                    addDocumentEvents(): void;
                    removeDocumentEvents(): void;
                    handleDocumentKeyDown(e: KeyboardEvent): void;
                    isInShadowDOM(node: Element | Text): boolean;
                    getEventPath(event: Event | {
                        path: string;
                    }): string | EventTarget[] | undefined;
                    composedPath(el: HTMLElement | null): (Document | Window | HTMLElement)[] | undefined;
                    matchInShadowDOM(node: Element | Text, e: Event): boolean;
                    handleDocumentClick(e: Event): void;
                    handleMaskClick(e: import("react").MouseEvent<Element>): void;
                    saveContentRef: (ref: import("react").ReactInstance & {
                        headerNode: HTMLElement;
                        bodyNode: HTMLElement;
                        footerNode: HTMLDivElement;
                    }) => void;
                    saveGatewayRef: (ref: InstanceType<{
                        new (props: import("@alifd/next/types/overlay").GatewayProps): {
                            child: Element | null | undefined;
                            componentDidMount(): void;
                            componentDidUpdate(): void;
                            updateContainer: () => void;
                            getChildNode(): Element | Text | null;
                            saveChildRef: (ref: HTMLDivElement) => void;
                            render(): import("react").ReactPortal | null;
                            context: any;
                            setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                            forceUpdate(callback?: () => void): void;
                            readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                                children?: import("react").ReactNode | undefined;
                            }>;
                            state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                            refs: {
                                [key: string]: import("react").ReactInstance;
                            };
                            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                            componentWillUnmount?(): void;
                            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                            componentWillMount?(): void;
                            UNSAFE_componentWillMount?(): void;
                            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        };
                        displayName: string;
                        propTypes: {
                            children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                            container: PropTypes.Requireable<any>;
                            target: PropTypes.Requireable<any>;
                        };
                        defaultProps: {
                            container: () => HTMLElement;
                        };
                        contextType?: import("react").Context<any> | undefined;
                    }> | null) => void;
                    getInstance(): /*elided*/ any;
                    render(): React.JSX.Element;
                    context: any;
                    setState<K extends keyof import("@alifd/next/types/overlay/types").OverlayState>(state: import("@alifd/next/types/overlay/types").OverlayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>) => import("@alifd/next/types/overlay/types").OverlayState | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>) | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>, callback?: () => void): void;
                    forceUpdate(callback?: () => void): void;
                    readonly props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props> & Readonly<{
                        children?: import("react").ReactNode | undefined;
                    }>;
                    state: Readonly<import("@alifd/next/types/overlay/types").OverlayState>;
                    refs: {
                        [key: string]: import("react").ReactInstance;
                    };
                    shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): boolean;
                    componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                    getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>): any;
                    componentWillMount?(): void;
                    UNSAFE_componentWillMount?(): void;
                    componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                    componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                    UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                };
                propTypes: {
                    prefix: PropTypes.Requireable<string>;
                    pure: PropTypes.Requireable<boolean>;
                    rtl: PropTypes.Requireable<boolean>;
                    className: PropTypes.Requireable<string>;
                    style: PropTypes.Requireable<object>;
                    children: PropTypes.Requireable<any>;
                    visible: PropTypes.Requireable<boolean>;
                    onRequestClose: PropTypes.Requireable<(...args: any[]) => any>;
                    target: PropTypes.Requireable<any>;
                    align: PropTypes.Requireable<string>;
                    offset: PropTypes.Requireable<any[]>;
                    container: PropTypes.Requireable<any>;
                    hasMask: PropTypes.Requireable<boolean>;
                    canCloseByEsc: PropTypes.Requireable<boolean>;
                    canCloseByOutSideClick: PropTypes.Requireable<boolean>;
                    canCloseByMask: PropTypes.Requireable<boolean>;
                    beforeOpen: PropTypes.Requireable<(...args: any[]) => any>;
                    onOpen: PropTypes.Requireable<(...args: any[]) => any>;
                    afterOpen: PropTypes.Requireable<(...args: any[]) => any>;
                    beforeClose: PropTypes.Requireable<(...args: any[]) => any>;
                    onClose: PropTypes.Requireable<(...args: any[]) => any>;
                    afterClose: PropTypes.Requireable<(...args: any[]) => any>;
                    beforePosition: PropTypes.Requireable<(...args: any[]) => any>;
                    onPosition: PropTypes.Requireable<(...args: any[]) => any>;
                    shouldUpdatePosition: PropTypes.Requireable<boolean>;
                    autoFocus: PropTypes.Requireable<boolean>;
                    needAdjust: PropTypes.Requireable<boolean>;
                    disableScroll: PropTypes.Requireable<boolean>;
                    useCapture: PropTypes.Requireable<boolean>;
                    cache: PropTypes.Requireable<boolean>;
                    safeNode: PropTypes.Requireable<any>;
                    wrapperClassName: PropTypes.Requireable<string>;
                    wrapperStyle: PropTypes.Requireable<object>;
                    animation: PropTypes.Requireable<NonNullable<boolean | object>>;
                    onMaskMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
                    onMaskMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
                    onClick: PropTypes.Requireable<(...args: any[]) => any>;
                    maskClass: PropTypes.Requireable<string>;
                    isChildrenInMask: PropTypes.Requireable<boolean>;
                    pinFollowBaseElementWhenFixed: PropTypes.Requireable<boolean>;
                    v2: PropTypes.Requireable<boolean>;
                    points: PropTypes.Requireable<any[]>;
                };
                defaultProps: {
                    prefix: string;
                    pure: boolean;
                    visible: boolean;
                    onRequestClose: () => void;
                    target: "viewport";
                    align: string;
                    offset: number[];
                    hasMask: boolean;
                    canCloseByEsc: boolean;
                    canCloseByOutSideClick: boolean;
                    canCloseByMask: boolean;
                    beforeOpen: () => void;
                    onOpen: () => void;
                    afterOpen: () => void;
                    beforeClose: () => void;
                    onClose: () => void;
                    afterClose: () => void;
                    beforePosition: () => void;
                    onPosition: () => void;
                    onMaskMouseEnter: () => void;
                    onMaskMouseLeave: () => void;
                    shouldUpdatePosition: boolean;
                    autoFocus: boolean;
                    needAdjust: boolean;
                    disableScroll: boolean;
                    cache: boolean;
                    isChildrenInMask: boolean;
                    onTouchEnd: (event: import("react").UIEvent) => void;
                    onClick: (event: import("react").UIEvent) => void;
                    maskClass: string;
                    useCapture: boolean;
                };
                displayName: string;
                getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay/types").OverlayV1Props, prevState: import("@alifd/next/types/overlay/types").OverlayState): Partial<import("@alifd/next/types/overlay/types").OverlayState>;
                contextType?: import("react").Context<any> | undefined;
            }> | null;
            saveRef(ref: InstanceType<{
                new (props: import("@alifd/next/types/overlay").PopupProps): {
                    _mouseNotFirstOnMask: boolean;
                    _isForwardContent: boolean | null;
                    overlay: InstanceType<{
                        new (props: import("@alifd/next/types/overlay/types").OverlayV1Props): {
                            lastAlign: string | boolean | undefined;
                            timeoutMap: {
                                [key: string]: number;
                            };
                            _isMounted: boolean;
                            _isDestroyed: boolean;
                            focusTimeout: number;
                            _animation: {
                                off: () => void;
                            } | null;
                            _containerNode: HTMLElement | undefined;
                            _hasFocused: boolean;
                            contentRef: import("react").ReactInstance & {
                                headerNode: HTMLElement;
                                bodyNode: HTMLElement;
                                footerNode: HTMLDivElement;
                            };
                            gatewayRef: InstanceType<{
                                new (props: import("@alifd/next/types/overlay").GatewayProps): {
                                    child: Element | null | undefined;
                                    componentDidMount(): void;
                                    componentDidUpdate(): void;
                                    updateContainer: () => void;
                                    getChildNode(): Element | Text | null;
                                    saveChildRef: (ref: HTMLDivElement) => void;
                                    render(): import("react").ReactPortal | null;
                                    context: any;
                                    setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                                    forceUpdate(callback?: () => void): void;
                                    readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                                        children?: import("react").ReactNode | undefined;
                                    }>;
                                    state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                                    refs: {
                                        [key: string]: import("react").ReactInstance;
                                    };
                                    shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                                    componentWillUnmount?(): void;
                                    componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                                    getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                                    componentWillMount?(): void;
                                    UNSAFE_componentWillMount?(): void;
                                    componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                                    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                                    componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                                    UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                                };
                                displayName: string;
                                propTypes: {
                                    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                                    container: PropTypes.Requireable<any>;
                                    target: PropTypes.Requireable<any>;
                                };
                                defaultProps: {
                                    container: () => HTMLElement;
                                };
                                contextType?: import("react").Context<any> | undefined;
                            }> | null;
                            _keydownEvents: {
                                off: () => void;
                            } | null;
                            _clickEvents: {
                                off: () => void;
                            } | null;
                            _touchEvents: {
                                off: () => void;
                            } | null;
                            overlay: InstanceType</*elided*/ any> | null;
                            componentDidMount(): void;
                            componentDidUpdate(prevProps: import("@alifd/next/types/overlay/types").OverlayV1Props): void;
                            componentWillUnmount(): void;
                            doAnimation(open: boolean, close: boolean): void;
                            getAnimation(props: import("@alifd/next/types/overlay/types").OverlayV1Props): string | boolean | import("@alifd/next/types/overlay/types").AnimationObjectType;
                            getAnimationByAlign(align: Array<string> | string | boolean | undefined): {
                                in: string;
                                out: string;
                            };
                            addAnimationEvents(): void;
                            handlePosition(config: {
                                align: Array<string>;
                            }): void;
                            handleAnimateEnd(id: string): void;
                            onEntering(): void;
                            onLeaving(): void;
                            onEntered(): void;
                            onLeaved(): void;
                            beforeOpen(): void;
                            beforeClose(): void;
                            setFocusNode(): void;
                            getContent(): React.ReactInstance & {
                                headerNode: HTMLElement;
                                bodyNode: HTMLElement;
                                footerNode: HTMLDivElement;
                            };
                            getContentNode(): HTMLElement | null;
                            getWrapperNode(): Element | null;
                            addDocumentEvents(): void;
                            removeDocumentEvents(): void;
                            handleDocumentKeyDown(e: KeyboardEvent): void;
                            isInShadowDOM(node: Element | Text): boolean;
                            getEventPath(event: Event | {
                                path: string;
                            }): string | EventTarget[] | undefined;
                            composedPath(el: HTMLElement | null): (Document | Window | HTMLElement)[] | undefined;
                            matchInShadowDOM(node: Element | Text, e: Event): boolean;
                            handleDocumentClick(e: Event): void;
                            handleMaskClick(e: import("react").MouseEvent<Element>): void;
                            saveContentRef: (ref: import("react").ReactInstance & {
                                headerNode: HTMLElement;
                                bodyNode: HTMLElement;
                                footerNode: HTMLDivElement;
                            }) => void;
                            saveGatewayRef: (ref: InstanceType<{
                                new (props: import("@alifd/next/types/overlay").GatewayProps): {
                                    child: Element | null | undefined;
                                    componentDidMount(): void;
                                    componentDidUpdate(): void;
                                    updateContainer: () => void;
                                    getChildNode(): Element | Text | null;
                                    saveChildRef: (ref: HTMLDivElement) => void;
                                    render(): import("react").ReactPortal | null;
                                    context: any;
                                    setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                                    forceUpdate(callback?: () => void): void;
                                    readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                                        children?: import("react").ReactNode | undefined;
                                    }>;
                                    state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                                    refs: {
                                        [key: string]: import("react").ReactInstance;
                                    };
                                    shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                                    componentWillUnmount?(): void;
                                    componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                                    getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                                    componentWillMount?(): void;
                                    UNSAFE_componentWillMount?(): void;
                                    componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                                    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                                    componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                                    UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                                };
                                displayName: string;
                                propTypes: {
                                    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                                    container: PropTypes.Requireable<any>;
                                    target: PropTypes.Requireable<any>;
                                };
                                defaultProps: {
                                    container: () => HTMLElement;
                                };
                                contextType?: import("react").Context<any> | undefined;
                            }> | null) => void;
                            getInstance(): /*elided*/ any;
                            render(): React.JSX.Element;
                            context: any;
                            setState<K extends keyof import("@alifd/next/types/overlay/types").OverlayState>(state: import("@alifd/next/types/overlay/types").OverlayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>) => import("@alifd/next/types/overlay/types").OverlayState | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>) | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>, callback?: () => void): void;
                            forceUpdate(callback?: () => void): void;
                            readonly props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props> & Readonly<{
                                children?: import("react").ReactNode | undefined;
                            }>;
                            state: Readonly<import("@alifd/next/types/overlay/types").OverlayState>;
                            refs: {
                                [key: string]: import("react").ReactInstance;
                            };
                            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): boolean;
                            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>): any;
                            componentWillMount?(): void;
                            UNSAFE_componentWillMount?(): void;
                            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                        };
                        propTypes: {
                            prefix: PropTypes.Requireable<string>;
                            pure: PropTypes.Requireable<boolean>;
                            rtl: PropTypes.Requireable<boolean>;
                            className: PropTypes.Requireable<string>;
                            style: PropTypes.Requireable<object>;
                            children: PropTypes.Requireable<any>;
                            visible: PropTypes.Requireable<boolean>;
                            onRequestClose: PropTypes.Requireable<(...args: any[]) => any>;
                            target: PropTypes.Requireable<any>;
                            align: PropTypes.Requireable<string>;
                            offset: PropTypes.Requireable<any[]>;
                            container: PropTypes.Requireable<any>;
                            hasMask: PropTypes.Requireable<boolean>;
                            canCloseByEsc: PropTypes.Requireable<boolean>;
                            canCloseByOutSideClick: PropTypes.Requireable<boolean>;
                            canCloseByMask: PropTypes.Requireable<boolean>;
                            beforeOpen: PropTypes.Requireable<(...args: any[]) => any>;
                            onOpen: PropTypes.Requireable<(...args: any[]) => any>;
                            afterOpen: PropTypes.Requireable<(...args: any[]) => any>;
                            beforeClose: PropTypes.Requireable<(...args: any[]) => any>;
                            onClose: PropTypes.Requireable<(...args: any[]) => any>;
                            afterClose: PropTypes.Requireable<(...args: any[]) => any>;
                            beforePosition: PropTypes.Requireable<(...args: any[]) => any>;
                            onPosition: PropTypes.Requireable<(...args: any[]) => any>;
                            shouldUpdatePosition: PropTypes.Requireable<boolean>;
                            autoFocus: PropTypes.Requireable<boolean>;
                            needAdjust: PropTypes.Requireable<boolean>;
                            disableScroll: PropTypes.Requireable<boolean>;
                            useCapture: PropTypes.Requireable<boolean>;
                            cache: PropTypes.Requireable<boolean>;
                            safeNode: PropTypes.Requireable<any>;
                            wrapperClassName: PropTypes.Requireable<string>;
                            wrapperStyle: PropTypes.Requireable<object>;
                            animation: PropTypes.Requireable<NonNullable<boolean | object>>;
                            onMaskMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
                            onMaskMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
                            onClick: PropTypes.Requireable<(...args: any[]) => any>;
                            maskClass: PropTypes.Requireable<string>;
                            isChildrenInMask: PropTypes.Requireable<boolean>;
                            pinFollowBaseElementWhenFixed: PropTypes.Requireable<boolean>;
                            v2: PropTypes.Requireable<boolean>;
                            points: PropTypes.Requireable<any[]>;
                        };
                        defaultProps: {
                            prefix: string;
                            pure: boolean;
                            visible: boolean;
                            onRequestClose: () => void;
                            target: "viewport";
                            align: string;
                            offset: number[];
                            hasMask: boolean;
                            canCloseByEsc: boolean;
                            canCloseByOutSideClick: boolean;
                            canCloseByMask: boolean;
                            beforeOpen: () => void;
                            onOpen: () => void;
                            afterOpen: () => void;
                            beforeClose: () => void;
                            onClose: () => void;
                            afterClose: () => void;
                            beforePosition: () => void;
                            onPosition: () => void;
                            onMaskMouseEnter: () => void;
                            onMaskMouseLeave: () => void;
                            shouldUpdatePosition: boolean;
                            autoFocus: boolean;
                            needAdjust: boolean;
                            disableScroll: boolean;
                            cache: boolean;
                            isChildrenInMask: boolean;
                            onTouchEnd: (event: import("react").UIEvent) => void;
                            onClick: (event: import("react").UIEvent) => void;
                            maskClass: string;
                            useCapture: boolean;
                        };
                        displayName: string;
                        getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay/types").OverlayV1Props, prevState: import("@alifd/next/types/overlay/types").OverlayState): Partial<import("@alifd/next/types/overlay/types").OverlayState>;
                        contextType?: import("react").Context<any> | undefined;
                    }> | null;
                    _timer: number | null;
                    _hideTimer: number | null;
                    _showTimer: number | null;
                    componentWillUnmount(): void;
                    handleVisibleChange(visible: boolean, type: string | object, e?: MouseEvent | KeyboardEvent): void;
                    handleTriggerClick(e: MouseEvent | KeyboardEvent): void;
                    handleTriggerKeyDown(e: KeyboardEvent): void;
                    handleTriggerMouseEnter(e: MouseEvent): void;
                    handleTriggerMouseLeave(e: MouseEvent, type: string | object): void;
                    handleTriggerFocus(e: MouseEvent): void;
                    handleTriggerBlur(e: MouseEvent): void;
                    handleContentMouseDown(): void;
                    handleContentMouseEnter(): void;
                    handleContentMouseLeave(e: MouseEvent): void;
                    handleMaskMouseEnter(): void;
                    handleMaskMouseLeave(): void;
                    handleRequestClose(type: string | object, e: MouseEvent): void;
                    renderTrigger(): React.ReactElement<any, any> | undefined;
                    renderContent(): React.ReactElement<any, any>;
                    renderPortal(): React.JSX.Element;
                    render(): (React.JSX.Element | undefined)[];
                    context: any;
                    setState<K extends "visible">(state: import("@alifd/next/types/overlay/types").PopupState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, props: Readonly<import("@alifd/next/types/overlay").PopupProps>) => import("@alifd/next/types/overlay/types").PopupState | Pick<import("@alifd/next/types/overlay/types").PopupState, K>) | Pick<import("@alifd/next/types/overlay/types").PopupState, K>, callback?: () => void): void;
                    forceUpdate(callback?: () => void): void;
                    readonly props: Readonly<import("@alifd/next/types/overlay").PopupProps> & Readonly<{
                        children?: import("react").ReactNode | undefined;
                    }>;
                    state: Readonly<import("@alifd/next/types/overlay/types").PopupState>;
                    refs: {
                        [key: string]: import("react").ReactInstance;
                    };
                    componentDidMount?(): void;
                    shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, nextContext: any): boolean;
                    componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                    getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").PopupState>): any;
                    componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, snapshot?: any): void;
                    componentWillMount?(): void;
                    UNSAFE_componentWillMount?(): void;
                    componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextContext: any): void;
                    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextContext: any): void;
                    componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, nextContext: any): void;
                    UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, nextContext: any): void;
                };
                propTypes: {
                    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                    trigger: PropTypes.Requireable<PropTypes.ReactElementLike>;
                    triggerType: PropTypes.Requireable<NonNullable<string | any[]>>;
                    triggerClickKeycode: PropTypes.Requireable<NonNullable<number | any[]>>;
                    visible: PropTypes.Requireable<boolean>;
                    defaultVisible: PropTypes.Requireable<boolean>;
                    onVisibleChange: PropTypes.Requireable<(...args: any[]) => any>;
                    disabled: PropTypes.Requireable<boolean>;
                    autoFit: PropTypes.Requireable<boolean>;
                    delay: PropTypes.Requireable<number>;
                    mouseEnterDelay: PropTypes.Requireable<number>;
                    mouseLeaveDelay: PropTypes.Requireable<number>;
                    canCloseByTrigger: PropTypes.Requireable<boolean>;
                    target: PropTypes.Requireable<any>;
                    safeNode: PropTypes.Requireable<any>;
                    followTrigger: PropTypes.Requireable<boolean>;
                    container: PropTypes.Requireable<any>;
                    hasMask: PropTypes.Requireable<boolean>;
                    wrapperStyle: PropTypes.Requireable<object>;
                    rtl: PropTypes.Requireable<boolean>;
                    v2: PropTypes.Requireable<boolean>;
                    placement: PropTypes.Requireable<string>;
                    placementOffset: PropTypes.Requireable<number>;
                    autoAdjust: PropTypes.Requireable<boolean>;
                };
                defaultProps: {
                    triggerType: string;
                    triggerClickKeycode: number[];
                    defaultVisible: boolean;
                    onVisibleChange: () => void;
                    disabled: boolean;
                    autoFit: boolean;
                    delay: number;
                    canCloseByTrigger: boolean;
                    followTrigger: boolean;
                    container: () => HTMLElement;
                    rtl: boolean;
                };
                displayName: string;
                getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay").PopupProps, prevState: import("@alifd/next/types/overlay/types").PopupState): {
                    visible: boolean | undefined;
                } | null;
                contextType?: import("react").Context<any> | undefined;
            }> | null): void;
            render(): React.JSX.Element;
            context: any;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/overlay").PopupProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
            forceUpdate(callback?: () => void): void;
            readonly props: Readonly<import("@alifd/next/types/overlay").PopupProps> & Readonly<{
                children?: import("react").ReactNode | undefined;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, Pick<{
            overlay: InstanceType<{
                new (props: import("@alifd/next/types/overlay/types").OverlayV1Props): {
                    lastAlign: string | boolean | undefined;
                    timeoutMap: {
                        [key: string]: number;
                    };
                    _isMounted: boolean;
                    _isDestroyed: boolean;
                    focusTimeout: number;
                    _animation: {
                        off: () => void;
                    } | null;
                    _containerNode: HTMLElement | undefined;
                    _hasFocused: boolean;
                    contentRef: import("react").ReactInstance & {
                        headerNode: HTMLElement;
                        bodyNode: HTMLElement;
                        footerNode: HTMLDivElement;
                    };
                    gatewayRef: InstanceType<{
                        new (props: import("@alifd/next/types/overlay").GatewayProps): {
                            child: Element | null | undefined;
                            componentDidMount(): void;
                            componentDidUpdate(): void;
                            updateContainer: () => void;
                            getChildNode(): Element | Text | null;
                            saveChildRef: (ref: HTMLDivElement) => void;
                            render(): import("react").ReactPortal | null;
                            context: any;
                            setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                            forceUpdate(callback?: () => void): void;
                            readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                                children?: import("react").ReactNode | undefined;
                            }>;
                            state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                            refs: {
                                [key: string]: import("react").ReactInstance;
                            };
                            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                            componentWillUnmount?(): void;
                            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                            componentWillMount?(): void;
                            UNSAFE_componentWillMount?(): void;
                            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        };
                        displayName: string;
                        propTypes: {
                            children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                            container: PropTypes.Requireable<any>;
                            target: PropTypes.Requireable<any>;
                        };
                        defaultProps: {
                            container: () => HTMLElement;
                        };
                        contextType?: import("react").Context<any> | undefined;
                    }> | null;
                    _keydownEvents: {
                        off: () => void;
                    } | null;
                    _clickEvents: {
                        off: () => void;
                    } | null;
                    _touchEvents: {
                        off: () => void;
                    } | null;
                    overlay: InstanceType</*elided*/ any> | null;
                    componentDidMount(): void;
                    componentDidUpdate(prevProps: import("@alifd/next/types/overlay/types").OverlayV1Props): void;
                    componentWillUnmount(): void;
                    doAnimation(open: boolean, close: boolean): void;
                    getAnimation(props: import("@alifd/next/types/overlay/types").OverlayV1Props): string | boolean | import("@alifd/next/types/overlay/types").AnimationObjectType;
                    getAnimationByAlign(align: Array<string> | string | boolean | undefined): {
                        in: string;
                        out: string;
                    };
                    addAnimationEvents(): void;
                    handlePosition(config: {
                        align: Array<string>;
                    }): void;
                    handleAnimateEnd(id: string): void;
                    onEntering(): void;
                    onLeaving(): void;
                    onEntered(): void;
                    onLeaved(): void;
                    beforeOpen(): void;
                    beforeClose(): void;
                    setFocusNode(): void;
                    getContent(): React.ReactInstance & {
                        headerNode: HTMLElement;
                        bodyNode: HTMLElement;
                        footerNode: HTMLDivElement;
                    };
                    getContentNode(): HTMLElement | null;
                    getWrapperNode(): Element | null;
                    addDocumentEvents(): void;
                    removeDocumentEvents(): void;
                    handleDocumentKeyDown(e: KeyboardEvent): void;
                    isInShadowDOM(node: Element | Text): boolean;
                    getEventPath(event: Event | {
                        path: string;
                    }): string | EventTarget[] | undefined;
                    composedPath(el: HTMLElement | null): (Document | Window | HTMLElement)[] | undefined;
                    matchInShadowDOM(node: Element | Text, e: Event): boolean;
                    handleDocumentClick(e: Event): void;
                    handleMaskClick(e: import("react").MouseEvent<Element>): void;
                    saveContentRef: (ref: import("react").ReactInstance & {
                        headerNode: HTMLElement;
                        bodyNode: HTMLElement;
                        footerNode: HTMLDivElement;
                    }) => void;
                    saveGatewayRef: (ref: InstanceType<{
                        new (props: import("@alifd/next/types/overlay").GatewayProps): {
                            child: Element | null | undefined;
                            componentDidMount(): void;
                            componentDidUpdate(): void;
                            updateContainer: () => void;
                            getChildNode(): Element | Text | null;
                            saveChildRef: (ref: HTMLDivElement) => void;
                            render(): import("react").ReactPortal | null;
                            context: any;
                            setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                            forceUpdate(callback?: () => void): void;
                            readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                                children?: import("react").ReactNode | undefined;
                            }>;
                            state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                            refs: {
                                [key: string]: import("react").ReactInstance;
                            };
                            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                            componentWillUnmount?(): void;
                            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                            componentWillMount?(): void;
                            UNSAFE_componentWillMount?(): void;
                            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                        };
                        displayName: string;
                        propTypes: {
                            children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                            container: PropTypes.Requireable<any>;
                            target: PropTypes.Requireable<any>;
                        };
                        defaultProps: {
                            container: () => HTMLElement;
                        };
                        contextType?: import("react").Context<any> | undefined;
                    }> | null) => void;
                    getInstance(): /*elided*/ any;
                    render(): React.JSX.Element;
                    context: any;
                    setState<K extends keyof import("@alifd/next/types/overlay/types").OverlayState>(state: import("@alifd/next/types/overlay/types").OverlayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>) => import("@alifd/next/types/overlay/types").OverlayState | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>) | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>, callback?: () => void): void;
                    forceUpdate(callback?: () => void): void;
                    readonly props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props> & Readonly<{
                        children?: import("react").ReactNode | undefined;
                    }>;
                    state: Readonly<import("@alifd/next/types/overlay/types").OverlayState>;
                    refs: {
                        [key: string]: import("react").ReactInstance;
                    };
                    shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): boolean;
                    componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                    getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>): any;
                    componentWillMount?(): void;
                    UNSAFE_componentWillMount?(): void;
                    componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                    componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                    UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                };
                propTypes: {
                    prefix: PropTypes.Requireable<string>;
                    pure: PropTypes.Requireable<boolean>;
                    rtl: PropTypes.Requireable<boolean>;
                    className: PropTypes.Requireable<string>;
                    style: PropTypes.Requireable<object>;
                    children: PropTypes.Requireable<any>;
                    visible: PropTypes.Requireable<boolean>;
                    onRequestClose: PropTypes.Requireable<(...args: any[]) => any>;
                    target: PropTypes.Requireable<any>;
                    align: PropTypes.Requireable<string>;
                    offset: PropTypes.Requireable<any[]>;
                    container: PropTypes.Requireable<any>;
                    hasMask: PropTypes.Requireable<boolean>;
                    canCloseByEsc: PropTypes.Requireable<boolean>;
                    canCloseByOutSideClick: PropTypes.Requireable<boolean>;
                    canCloseByMask: PropTypes.Requireable<boolean>;
                    beforeOpen: PropTypes.Requireable<(...args: any[]) => any>;
                    onOpen: PropTypes.Requireable<(...args: any[]) => any>;
                    afterOpen: PropTypes.Requireable<(...args: any[]) => any>;
                    beforeClose: PropTypes.Requireable<(...args: any[]) => any>;
                    onClose: PropTypes.Requireable<(...args: any[]) => any>;
                    afterClose: PropTypes.Requireable<(...args: any[]) => any>;
                    beforePosition: PropTypes.Requireable<(...args: any[]) => any>;
                    onPosition: PropTypes.Requireable<(...args: any[]) => any>;
                    shouldUpdatePosition: PropTypes.Requireable<boolean>;
                    autoFocus: PropTypes.Requireable<boolean>;
                    needAdjust: PropTypes.Requireable<boolean>;
                    disableScroll: PropTypes.Requireable<boolean>;
                    useCapture: PropTypes.Requireable<boolean>;
                    cache: PropTypes.Requireable<boolean>;
                    safeNode: PropTypes.Requireable<any>;
                    wrapperClassName: PropTypes.Requireable<string>;
                    wrapperStyle: PropTypes.Requireable<object>;
                    animation: PropTypes.Requireable<NonNullable<boolean | object>>;
                    onMaskMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
                    onMaskMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
                    onClick: PropTypes.Requireable<(...args: any[]) => any>;
                    maskClass: PropTypes.Requireable<string>;
                    isChildrenInMask: PropTypes.Requireable<boolean>;
                    pinFollowBaseElementWhenFixed: PropTypes.Requireable<boolean>;
                    v2: PropTypes.Requireable<boolean>;
                    points: PropTypes.Requireable<any[]>;
                };
                defaultProps: {
                    prefix: string;
                    pure: boolean;
                    visible: boolean;
                    onRequestClose: () => void;
                    target: "viewport";
                    align: string;
                    offset: number[];
                    hasMask: boolean;
                    canCloseByEsc: boolean;
                    canCloseByOutSideClick: boolean;
                    canCloseByMask: boolean;
                    beforeOpen: () => void;
                    onOpen: () => void;
                    afterOpen: () => void;
                    beforeClose: () => void;
                    onClose: () => void;
                    afterClose: () => void;
                    beforePosition: () => void;
                    onPosition: () => void;
                    onMaskMouseEnter: () => void;
                    onMaskMouseLeave: () => void;
                    shouldUpdatePosition: boolean;
                    autoFocus: boolean;
                    needAdjust: boolean;
                    disableScroll: boolean;
                    cache: boolean;
                    isChildrenInMask: boolean;
                    onTouchEnd: (event: import("react").UIEvent) => void;
                    onClick: (event: import("react").UIEvent) => void;
                    maskClass: string;
                    useCapture: boolean;
                };
                displayName: string;
                getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay/types").OverlayV1Props, prevState: import("@alifd/next/types/overlay/types").OverlayState): Partial<import("@alifd/next/types/overlay/types").OverlayState>;
                contextType?: import("react").Context<any> | undefined;
            }> | null;
            saveRef(ref: InstanceType<{
                new (props: import("@alifd/next/types/overlay").PopupProps): {
                    _mouseNotFirstOnMask: boolean;
                    _isForwardContent: boolean | null;
                    overlay: InstanceType<{
                        new (props: import("@alifd/next/types/overlay/types").OverlayV1Props): {
                            lastAlign: string | boolean | undefined;
                            timeoutMap: {
                                [key: string]: number;
                            };
                            _isMounted: boolean;
                            _isDestroyed: boolean;
                            focusTimeout: number;
                            _animation: {
                                off: () => void;
                            } | null;
                            _containerNode: HTMLElement | undefined;
                            _hasFocused: boolean;
                            contentRef: import("react").ReactInstance & {
                                headerNode: HTMLElement;
                                bodyNode: HTMLElement;
                                footerNode: HTMLDivElement;
                            };
                            gatewayRef: InstanceType<{
                                new (props: import("@alifd/next/types/overlay").GatewayProps): {
                                    child: Element | null | undefined;
                                    componentDidMount(): void;
                                    componentDidUpdate(): void;
                                    updateContainer: () => void;
                                    getChildNode(): Element | Text | null;
                                    saveChildRef: (ref: HTMLDivElement) => void;
                                    render(): import("react").ReactPortal | null;
                                    context: any;
                                    setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                                    forceUpdate(callback?: () => void): void;
                                    readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                                        children?: import("react").ReactNode | undefined;
                                    }>;
                                    state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                                    refs: {
                                        [key: string]: import("react").ReactInstance;
                                    };
                                    shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                                    componentWillUnmount?(): void;
                                    componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                                    getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                                    componentWillMount?(): void;
                                    UNSAFE_componentWillMount?(): void;
                                    componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                                    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                                    componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                                    UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                                };
                                displayName: string;
                                propTypes: {
                                    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                                    container: PropTypes.Requireable<any>;
                                    target: PropTypes.Requireable<any>;
                                };
                                defaultProps: {
                                    container: () => HTMLElement;
                                };
                                contextType?: import("react").Context<any> | undefined;
                            }> | null;
                            _keydownEvents: {
                                off: () => void;
                            } | null;
                            _clickEvents: {
                                off: () => void;
                            } | null;
                            _touchEvents: {
                                off: () => void;
                            } | null;
                            overlay: InstanceType</*elided*/ any> | null;
                            componentDidMount(): void;
                            componentDidUpdate(prevProps: import("@alifd/next/types/overlay/types").OverlayV1Props): void;
                            componentWillUnmount(): void;
                            doAnimation(open: boolean, close: boolean): void;
                            getAnimation(props: import("@alifd/next/types/overlay/types").OverlayV1Props): string | boolean | import("@alifd/next/types/overlay/types").AnimationObjectType;
                            getAnimationByAlign(align: Array<string> | string | boolean | undefined): {
                                in: string;
                                out: string;
                            };
                            addAnimationEvents(): void;
                            handlePosition(config: {
                                align: Array<string>;
                            }): void;
                            handleAnimateEnd(id: string): void;
                            onEntering(): void;
                            onLeaving(): void;
                            onEntered(): void;
                            onLeaved(): void;
                            beforeOpen(): void;
                            beforeClose(): void;
                            setFocusNode(): void;
                            getContent(): React.ReactInstance & {
                                headerNode: HTMLElement;
                                bodyNode: HTMLElement;
                                footerNode: HTMLDivElement;
                            };
                            getContentNode(): HTMLElement | null;
                            getWrapperNode(): Element | null;
                            addDocumentEvents(): void;
                            removeDocumentEvents(): void;
                            handleDocumentKeyDown(e: KeyboardEvent): void;
                            isInShadowDOM(node: Element | Text): boolean;
                            getEventPath(event: Event | {
                                path: string;
                            }): string | EventTarget[] | undefined;
                            composedPath(el: HTMLElement | null): (Document | Window | HTMLElement)[] | undefined;
                            matchInShadowDOM(node: Element | Text, e: Event): boolean;
                            handleDocumentClick(e: Event): void;
                            handleMaskClick(e: import("react").MouseEvent<Element>): void;
                            saveContentRef: (ref: import("react").ReactInstance & {
                                headerNode: HTMLElement;
                                bodyNode: HTMLElement;
                                footerNode: HTMLDivElement;
                            }) => void;
                            saveGatewayRef: (ref: InstanceType<{
                                new (props: import("@alifd/next/types/overlay").GatewayProps): {
                                    child: Element | null | undefined;
                                    componentDidMount(): void;
                                    componentDidUpdate(): void;
                                    updateContainer: () => void;
                                    getChildNode(): Element | Text | null;
                                    saveChildRef: (ref: HTMLDivElement) => void;
                                    render(): import("react").ReactPortal | null;
                                    context: any;
                                    setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K>, callback?: () => void): void;
                                    forceUpdate(callback?: () => void): void;
                                    readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                                        children?: import("react").ReactNode | undefined;
                                    }>;
                                    state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                                    refs: {
                                        [key: string]: import("react").ReactInstance;
                                    };
                                    shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                                    componentWillUnmount?(): void;
                                    componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                                    getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                                    componentWillMount?(): void;
                                    UNSAFE_componentWillMount?(): void;
                                    componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                                    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                                    componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                                    UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                                };
                                displayName: string;
                                propTypes: {
                                    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                                    container: PropTypes.Requireable<any>;
                                    target: PropTypes.Requireable<any>;
                                };
                                defaultProps: {
                                    container: () => HTMLElement;
                                };
                                contextType?: import("react").Context<any> | undefined;
                            }> | null) => void;
                            getInstance(): /*elided*/ any;
                            render(): React.JSX.Element;
                            context: any;
                            setState<K extends keyof import("@alifd/next/types/overlay/types").OverlayState>(state: import("@alifd/next/types/overlay/types").OverlayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>) => import("@alifd/next/types/overlay/types").OverlayState | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>) | Pick<import("@alifd/next/types/overlay/types").OverlayState, K>, callback?: () => void): void;
                            forceUpdate(callback?: () => void): void;
                            readonly props: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props> & Readonly<{
                                children?: import("react").ReactNode | undefined;
                            }>;
                            state: Readonly<import("@alifd/next/types/overlay/types").OverlayState>;
                            refs: {
                                [key: string]: import("react").ReactInstance;
                            };
                            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): boolean;
                            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, prevState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>): any;
                            componentWillMount?(): void;
                            UNSAFE_componentWillMount?(): void;
                            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextContext: any): void;
                            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay/types").OverlayV1Props>, nextState: Readonly<import("@alifd/next/types/overlay/types").OverlayState>, nextContext: any): void;
                        };
                        propTypes: {
                            prefix: PropTypes.Requireable<string>;
                            pure: PropTypes.Requireable<boolean>;
                            rtl: PropTypes.Requireable<boolean>;
                            className: PropTypes.Requireable<string>;
                            style: PropTypes.Requireable<object>;
                            children: PropTypes.Requireable<any>;
                            visible: PropTypes.Requireable<boolean>;
                            onRequestClose: PropTypes.Requireable<(...args: any[]) => any>;
                            target: PropTypes.Requireable<any>;
                            align: PropTypes.Requireable<string>;
                            offset: PropTypes.Requireable<any[]>;
                            container: PropTypes.Requireable<any>;
                            hasMask: PropTypes.Requireable<boolean>;
                            canCloseByEsc: PropTypes.Requireable<boolean>;
                            canCloseByOutSideClick: PropTypes.Requireable<boolean>;
                            canCloseByMask: PropTypes.Requireable<boolean>;
                            beforeOpen: PropTypes.Requireable<(...args: any[]) => any>;
                            onOpen: PropTypes.Requireable<(...args: any[]) => any>;
                            afterOpen: PropTypes.Requireable<(...args: any[]) => any>;
                            beforeClose: PropTypes.Requireable<(...args: any[]) => any>;
                            onClose: PropTypes.Requireable<(...args: any[]) => any>;
                            afterClose: PropTypes.Requireable<(...args: any[]) => any>;
                            beforePosition: PropTypes.Requireable<(...args: any[]) => any>;
                            onPosition: PropTypes.Requireable<(...args: any[]) => any>;
                            shouldUpdatePosition: PropTypes.Requireable<boolean>;
                            autoFocus: PropTypes.Requireable<boolean>;
                            needAdjust: PropTypes.Requireable<boolean>;
                            disableScroll: PropTypes.Requireable<boolean>;
                            useCapture: PropTypes.Requireable<boolean>;
                            cache: PropTypes.Requireable<boolean>;
                            safeNode: PropTypes.Requireable<any>;
                            wrapperClassName: PropTypes.Requireable<string>;
                            wrapperStyle: PropTypes.Requireable<object>;
                            animation: PropTypes.Requireable<NonNullable<boolean | object>>;
                            onMaskMouseEnter: PropTypes.Requireable<(...args: any[]) => any>;
                            onMaskMouseLeave: PropTypes.Requireable<(...args: any[]) => any>;
                            onClick: PropTypes.Requireable<(...args: any[]) => any>;
                            maskClass: PropTypes.Requireable<string>;
                            isChildrenInMask: PropTypes.Requireable<boolean>;
                            pinFollowBaseElementWhenFixed: PropTypes.Requireable<boolean>;
                            v2: PropTypes.Requireable<boolean>;
                            points: PropTypes.Requireable<any[]>;
                        };
                        defaultProps: {
                            prefix: string;
                            pure: boolean;
                            visible: boolean;
                            onRequestClose: () => void;
                            target: "viewport";
                            align: string;
                            offset: number[];
                            hasMask: boolean;
                            canCloseByEsc: boolean;
                            canCloseByOutSideClick: boolean;
                            canCloseByMask: boolean;
                            beforeOpen: () => void;
                            onOpen: () => void;
                            afterOpen: () => void;
                            beforeClose: () => void;
                            onClose: () => void;
                            afterClose: () => void;
                            beforePosition: () => void;
                            onPosition: () => void;
                            onMaskMouseEnter: () => void;
                            onMaskMouseLeave: () => void;
                            shouldUpdatePosition: boolean;
                            autoFocus: boolean;
                            needAdjust: boolean;
                            disableScroll: boolean;
                            cache: boolean;
                            isChildrenInMask: boolean;
                            onTouchEnd: (event: import("react").UIEvent) => void;
                            onClick: (event: import("react").UIEvent) => void;
                            maskClass: string;
                            useCapture: boolean;
                        };
                        displayName: string;
                        getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay/types").OverlayV1Props, prevState: import("@alifd/next/types/overlay/types").OverlayState): Partial<import("@alifd/next/types/overlay/types").OverlayState>;
                        contextType?: import("react").Context<any> | undefined;
                    }> | null;
                    _timer: number | null;
                    _hideTimer: number | null;
                    _showTimer: number | null;
                    componentWillUnmount(): void;
                    handleVisibleChange(visible: boolean, type: string | object, e?: MouseEvent | KeyboardEvent): void;
                    handleTriggerClick(e: MouseEvent | KeyboardEvent): void;
                    handleTriggerKeyDown(e: KeyboardEvent): void;
                    handleTriggerMouseEnter(e: MouseEvent): void;
                    handleTriggerMouseLeave(e: MouseEvent, type: string | object): void;
                    handleTriggerFocus(e: MouseEvent): void;
                    handleTriggerBlur(e: MouseEvent): void;
                    handleContentMouseDown(): void;
                    handleContentMouseEnter(): void;
                    handleContentMouseLeave(e: MouseEvent): void;
                    handleMaskMouseEnter(): void;
                    handleMaskMouseLeave(): void;
                    handleRequestClose(type: string | object, e: MouseEvent): void;
                    renderTrigger(): React.ReactElement<any, any> | undefined;
                    renderContent(): React.ReactElement<any, any>;
                    renderPortal(): React.JSX.Element;
                    render(): (React.JSX.Element | undefined)[];
                    context: any;
                    setState<K extends "visible">(state: import("@alifd/next/types/overlay/types").PopupState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, props: Readonly<import("@alifd/next/types/overlay").PopupProps>) => import("@alifd/next/types/overlay/types").PopupState | Pick<import("@alifd/next/types/overlay/types").PopupState, K>) | Pick<import("@alifd/next/types/overlay/types").PopupState, K>, callback?: () => void): void;
                    forceUpdate(callback?: () => void): void;
                    readonly props: Readonly<import("@alifd/next/types/overlay").PopupProps> & Readonly<{
                        children?: import("react").ReactNode | undefined;
                    }>;
                    state: Readonly<import("@alifd/next/types/overlay/types").PopupState>;
                    refs: {
                        [key: string]: import("react").ReactInstance;
                    };
                    componentDidMount?(): void;
                    shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, nextContext: any): boolean;
                    componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                    getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").PopupState>): any;
                    componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, snapshot?: any): void;
                    componentWillMount?(): void;
                    UNSAFE_componentWillMount?(): void;
                    componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextContext: any): void;
                    UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextContext: any): void;
                    componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, nextContext: any): void;
                    UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").PopupState>, nextContext: any): void;
                };
                propTypes: {
                    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
                    trigger: PropTypes.Requireable<PropTypes.ReactElementLike>;
                    triggerType: PropTypes.Requireable<NonNullable<string | any[]>>;
                    triggerClickKeycode: PropTypes.Requireable<NonNullable<number | any[]>>;
                    visible: PropTypes.Requireable<boolean>;
                    defaultVisible: PropTypes.Requireable<boolean>;
                    onVisibleChange: PropTypes.Requireable<(...args: any[]) => any>;
                    disabled: PropTypes.Requireable<boolean>;
                    autoFit: PropTypes.Requireable<boolean>;
                    delay: PropTypes.Requireable<number>;
                    mouseEnterDelay: PropTypes.Requireable<number>;
                    mouseLeaveDelay: PropTypes.Requireable<number>;
                    canCloseByTrigger: PropTypes.Requireable<boolean>;
                    target: PropTypes.Requireable<any>;
                    safeNode: PropTypes.Requireable<any>;
                    followTrigger: PropTypes.Requireable<boolean>;
                    container: PropTypes.Requireable<any>;
                    hasMask: PropTypes.Requireable<boolean>;
                    wrapperStyle: PropTypes.Requireable<object>;
                    rtl: PropTypes.Requireable<boolean>;
                    v2: PropTypes.Requireable<boolean>;
                    placement: PropTypes.Requireable<string>;
                    placementOffset: PropTypes.Requireable<number>;
                    autoAdjust: PropTypes.Requireable<boolean>;
                };
                defaultProps: {
                    triggerType: string;
                    triggerClickKeycode: number[];
                    defaultVisible: boolean;
                    onVisibleChange: () => void;
                    disabled: boolean;
                    autoFit: boolean;
                    delay: number;
                    canCloseByTrigger: boolean;
                    followTrigger: boolean;
                    container: () => HTMLElement;
                    rtl: boolean;
                };
                displayName: string;
                getDerivedStateFromProps(nextProps: import("@alifd/next/types/overlay").PopupProps, prevState: import("@alifd/next/types/overlay/types").PopupState): {
                    visible: boolean | undefined;
                } | null;
                contextType?: import("react").Context<any> | undefined;
            }> | null): void;
            render(): React.JSX.Element;
            context: any;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/overlay").PopupProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
            forceUpdate(callback?: () => void): void;
            readonly props: Readonly<import("@alifd/next/types/overlay").PopupProps> & Readonly<{
                children?: import("react").ReactNode | undefined;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").PopupProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, "overlay">>;
        Gateway: {
            new (props: import("@alifd/next/types/overlay").GatewayProps): {
                child: Element | null | undefined;
                componentDidMount(): void;
                componentDidUpdate(): void;
                updateContainer: () => void;
                getChildNode(): Element | Text | null;
                saveChildRef: (ref: HTMLDivElement) => void;
                render(): React.ReactPortal | null;
                context: any;
                setState<K extends "containerNode">(state: import("@alifd/next/types/overlay/types").GatewayState | ((prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, props: Readonly<import("@alifd/next/types/overlay").GatewayProps>) => import("@alifd/next/types/overlay/types").GatewayState | Pick<import("@alifd/next/types/overlay/types").GatewayState, K> | null) | Pick<import("@alifd/next/types/overlay/types").GatewayState, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<import("@alifd/next/types/overlay").GatewayProps> & Readonly<{
                    children?: React.ReactNode;
                }>;
                state: Readonly<import("@alifd/next/types/overlay/types").GatewayState>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, prevState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>): any;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/overlay").GatewayProps>, nextState: Readonly<import("@alifd/next/types/overlay/types").GatewayState>, nextContext: any): void;
            };
            displayName: string;
            propTypes: {
                children: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
                container: import("prop-types").Requireable<any>;
                target: import("prop-types").Requireable<any>;
            };
            defaultProps: {
                container: () => HTMLElement;
            };
            contextType?: React.Context<any> | undefined;
        };
        Position: typeof import("@alifd/next/types/overlay/position").default;
    };
    Pagination: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/pagination").PaginationProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        readonly props: Readonly<import("@alifd/next/types/util").RequiredSome<import("@alifd/next/types/pagination").PaginationProps, "type" | "rtl" | "total" | "prefix" | "size" | "onChange" | "shape" | "pageSize" | "locale" | "pure" | "defaultCurrent" | "pageShowCount" | "pageSizeSelector" | "pageSizeList" | "pageNumberRender" | "pageSizePosition" | "useFloatLayout" | "onPageSizeChange" | "hideOnlyOnePage" | "showJump">> & Readonly<Pick<{
            prefix: string;
            pure: boolean;
            rtl: boolean;
            locale: Partial<{
                prev: string;
                next: string;
                goTo: string;
                page: string;
                go: string;
                total: string;
                labelPrev: string;
                labelNext: string;
                inputAriaLabel: string;
                selectAriaLabel: string;
                pageSize: string;
            }> & {
                momentLocale?: string | undefined;
            };
            type: string;
            shape: string;
            size: string;
            defaultCurrent: number;
            onChange: () => void;
            pageSize: number;
            pageSizeSelector: boolean;
            pageSizeList: number[];
            pageSizePosition: string;
            onPageSizeChange: () => void;
            useFloatLayout: boolean;
            total: number;
            pageShowCount: number;
            hideOnlyOnePage: boolean;
            showJump: boolean;
            pageNumberRender: (index: number) => import("react").ReactNode;
        }, never>>;
        handleJump: (e: import("react").KeyboardEvent<Element> | import("react").MouseEvent<Element>) => void;
        onPageItemClick(page: number, e: import("react").KeyboardEvent<Element> | import("react").MouseEvent<Element>): void;
        onInputChange(value: string): void;
        onSelectSize(pageSize: number): void;
        renderPageTotal(): React.JSX.Element;
        renderPageItem(index: number): React.JSX.Element;
        renderPageFirst(current: number): React.JSX.Element;
        renderPageLast(current: number, totalPage: number): React.JSX.Element;
        renderPageEllipsis(idx: number): React.JSX.Element;
        renderPageJump(): React.JSX.Element[];
        renderPageDisplay(current: number, totalPage: number): React.JSX.Element;
        renderPageList(current: number, totalPage: number): React.JSX.Element;
        renderPageSizeSelector(): React.JSX.Element | null;
        renderPageSizeFilter(): React.JSX.Element;
        renderPageSizeDropdown(): React.JSX.Element;
        render(): React.JSX.Element | null;
        context: any;
        setState<K extends keyof import("@alifd/next/types/pagination/types").PaginationState>(state: import("@alifd/next/types/pagination/types").PaginationState | ((prevState: Readonly<import("@alifd/next/types/pagination/types").PaginationState>, props: Readonly<import("@alifd/next/types/pagination").PaginationProps>) => import("@alifd/next/types/pagination/types").PaginationState | Pick<import("@alifd/next/types/pagination/types").PaginationState, K>) | Pick<import("@alifd/next/types/pagination/types").PaginationState, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        state: Readonly<import("@alifd/next/types/pagination/types").PaginationState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/pagination").PaginationProps>, nextState: Readonly<import("@alifd/next/types/pagination/types").PaginationState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/pagination").PaginationProps>, prevState: Readonly<import("@alifd/next/types/pagination/types").PaginationState>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/pagination").PaginationProps>, prevState: Readonly<import("@alifd/next/types/pagination/types").PaginationState>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/pagination").PaginationProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/pagination").PaginationProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/pagination").PaginationProps>, nextState: Readonly<import("@alifd/next/types/pagination/types").PaginationState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/pagination").PaginationProps>, nextState: Readonly<import("@alifd/next/types/pagination/types").PaginationState>, nextContext: any): void;
    }, {}>;
    Radio: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/radio").RadioProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/radio/types").WrappedRadio, {}> & {
        Group: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/radio").GroupProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/radio/radio-group").RadioGroup, {}>;
    };
    Search: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/search").SearchProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        highlightKey: unknown;
        inputRef: {
            isInputing: boolean;
            componentDidUpdate(prevProps: import("@alifd/next/types/select").AutoCompleteProps): void;
            shouldControlPopup(props: (Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>) | undefined, type: import("@alifd/next/types/select").VisibleChangeType): void;
            handleMenuSelect(keys: string[]): void;
            handleItemClick(): void;
            handleSelectEvent(key: string, item: import("@alifd/next/types/select").ObjectItem, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
            handleChange: (value: string, proxy: import("@alifd/next/types/select").VisibleChangeType | import("react").ChangeEvent<HTMLElement>, item?: import("@alifd/next/types/select").ObjectItem | undefined) => false | undefined;
            handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
            beforeClose(): void;
            handleTriggerKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
            chooseHighlightItem(): false | undefined;
            hasClear(): boolean | "" | undefined;
            renderSelect(props?: Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>): import("react").JSX.Element;
            render(): import("react").JSX.Element;
            dataStore: import("@alifd/next/types/select/data-store").default;
            selectDOM: HTMLElement;
            width: string | number;
            popupRef: HTMLDivElement;
            resizeTimeout: number;
            highlightTimer: number | undefined;
            menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
            isAutoComplete: boolean;
            inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
            valueDataSource: {
                value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
                valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
                mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
            };
            componentDidMount(): void;
            componentWillUnmount(): void;
            syncWidth(): void;
            handleResize(): void;
            setDataSource(props: import("@alifd/next/types/select").AutoCompleteProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
            setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
            setFirstHightLightKeyForMenu(searchValue?: unknown): void;
            handleMenuBodyClick(): void;
            toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
            scrollMenuIntoView(): void;
            renderMenuHeader(): import("react").ReactNode;
            handleSelect(): void;
            handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            useDetailValue(): boolean;
            renderMenu(): import("react").JSX.Element;
            renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            saveSelectRef: (ref: HTMLElement | null) => void;
            saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
            focusInput(): void;
            focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
            beforeOpen(): void;
            afterClose(): void;
            savePopupRef: (ref: HTMLDivElement) => void;
            shouldAutoWidth(): boolean | undefined;
            context: any;
            setState<K extends keyof import("@alifd/next/types/select/auto-complete").AutoCompleteState>(state: import("@alifd/next/types/select/auto-complete").AutoCompleteState | ((prevState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, props: Readonly<import("@alifd/next/types/select").AutoCompleteProps>) => import("@alifd/next/types/select/auto-complete").AutoCompleteState | Pick<import("@alifd/next/types/select/auto-complete").AutoCompleteState, K> | null) | Pick<import("@alifd/next/types/select/auto-complete").AutoCompleteState, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, prevState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): void;
        } | null;
        onChange: (value: string, actionType: string, item?: import("@alifd/next/types/select").ObjectItem | undefined) => void;
        onPressEnter: () => void;
        onSearch: () => void;
        onFilterChange: (filterValue: string) => void;
        onToggleHighlightItem: (highlightKey?: string | boolean | import("@alifd/next/types/select/types").NormalizedObjectItem | null | undefined, type?: import("@alifd/next/types/select/types").HighlightChangeType | undefined) => void;
        onKeyDown: (e: import("react").KeyboardEvent<Element>) => void;
        saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/select").AutoCompleteProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            isInputing: boolean;
            componentDidUpdate(prevProps: import("@alifd/next/types/select").AutoCompleteProps): void;
            shouldControlPopup(props: (Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>) | undefined, type: import("@alifd/next/types/select").VisibleChangeType): void;
            handleMenuSelect(keys: string[]): void;
            handleItemClick(): void;
            handleSelectEvent(key: string, item: import("@alifd/next/types/select").ObjectItem, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
            handleChange: (value: string, proxy: import("@alifd/next/types/select").VisibleChangeType | import("react").ChangeEvent<HTMLElement>, item?: import("@alifd/next/types/select").ObjectItem | undefined) => false | undefined;
            handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
            beforeClose(): void;
            handleTriggerKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
            chooseHighlightItem(): false | undefined;
            hasClear(): boolean | "" | undefined;
            renderSelect(props?: Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>): import("react").JSX.Element;
            render(): import("react").JSX.Element;
            dataStore: import("@alifd/next/types/select/data-store").default;
            selectDOM: HTMLElement;
            width: string | number;
            popupRef: HTMLDivElement;
            resizeTimeout: number;
            highlightTimer: number | undefined;
            menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
            isAutoComplete: boolean;
            inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
            valueDataSource: {
                value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
                valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
                mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
            };
            componentDidMount(): void;
            componentWillUnmount(): void;
            syncWidth(): void;
            handleResize(): void;
            setDataSource(props: import("@alifd/next/types/select").AutoCompleteProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
            setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
            setFirstHightLightKeyForMenu(searchValue?: unknown): void;
            handleMenuBodyClick(): void;
            toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
            scrollMenuIntoView(): void;
            renderMenuHeader(): import("react").ReactNode;
            handleSelect(): void;
            handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            useDetailValue(): boolean;
            renderMenu(): import("react").JSX.Element;
            renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            saveSelectRef: (ref: HTMLElement | null) => void;
            saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
            focusInput(): void;
            focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
            beforeOpen(): void;
            afterClose(): void;
            savePopupRef: (ref: HTMLDivElement) => void;
            shouldAutoWidth(): boolean | undefined;
            context: any;
            setState<K extends keyof import("@alifd/next/types/select/auto-complete").AutoCompleteState>(state: import("@alifd/next/types/select/auto-complete").AutoCompleteState | ((prevState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, props: Readonly<import("@alifd/next/types/select").AutoCompleteProps>) => import("@alifd/next/types/select/auto-complete").AutoCompleteState | Pick<import("@alifd/next/types/select/auto-complete").AutoCompleteState, K> | null) | Pick<import("@alifd/next/types/select/auto-complete").AutoCompleteState, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, prevState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): void;
        }>) => void;
        focus: (start?: number | undefined, end?: number | undefined, preventScroll?: boolean) => void;
        handleFocus(args_0: import("react").FocusEvent<HTMLInputElement, Element>): void;
        handleBlur(args_0: import("react").FocusEvent<HTMLInputElement, Element>): void;
        render(): import("react").JSX.Element;
        context: any;
        setState<K_1 extends keyof import("@alifd/next/types/search/Search").SearchState>(state: import("@alifd/next/types/search/Search").SearchState | ((prevState: Readonly<import("@alifd/next/types/search/Search").SearchState>, props: Readonly<import("@alifd/next/types/search").SearchProps>) => import("@alifd/next/types/search/Search").SearchState | Pick<import("@alifd/next/types/search/Search").SearchState, K_1> | null) | Pick<import("@alifd/next/types/search/Search").SearchState, K_1> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("@alifd/next/types/search").SearchProps> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<import("@alifd/next/types/search/Search").SearchState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/search").SearchProps>, nextState: Readonly<import("@alifd/next/types/search/Search").SearchState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/search").SearchProps>, prevState: Readonly<import("@alifd/next/types/search/Search").SearchState>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/search").SearchProps>, prevState: Readonly<import("@alifd/next/types/search/Search").SearchState>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/search").SearchProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/search").SearchProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/search").SearchProps>, nextState: Readonly<import("@alifd/next/types/search/Search").SearchState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/search").SearchProps>, nextState: Readonly<import("@alifd/next/types/search/Search").SearchState>, nextContext: any): void;
    }, {}>;
    Select: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/select").SelectProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        selectAllYet: boolean;
        componentDidUpdate(prevProps: import("@alifd/next/types/select").SelectProps, prevState: import("@alifd/next/types/select/base").BaseState): void;
        componentDidMount(): void;
        ie9Hack(): void;
        useDetailValue(): boolean;
        hasSearch(): boolean;
        getTagSize(): "small" | "medium" | "large" | undefined;
        handleMenuSelect(keys: string[], item: {
            props: {
                _key: string;
            };
        }): false | void;
        handleItemClick(key: string): void;
        handleSingleSelect(key: string, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
        handleMultipleSelect(keys: import("@alifd/next/types/select").DataSourceItem[] | undefined, triggerType: import("@alifd/next/types/select").VisibleChangeType, key?: string | null | undefined, keepSearchValue?: boolean | undefined): void;
        updateSelectAllYet(value?: unknown): void;
        handleSearchValue(value: string): void;
        handleSearch(value: string, e: import("react").ChangeEvent<HTMLInputElement>): void;
        handleSearchClear(triggerType?: string | undefined): void;
        handleSearchKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
        chooseMultipleItem(key: string): void;
        chooseHighlightItem(proxy: unknown, e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
        handleTagClose(item: import("@alifd/next/types/select").ObjectItem): boolean;
        handleDeleteTag(e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
        handleSelectAll(e: import("react").UIEvent<HTMLElement, UIEvent>): void;
        handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
        afterClose(): void;
        maxTagPlaceholder(selectedValues: import("@alifd/next/types/select").ObjectItem[], totalValues: import("@alifd/next/types/select").ObjectItem[]): string;
        renderValues(): import("react").ReactNode;
        handleWrapClick: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
        handleArrowClick: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
        handleClear: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
        hasClear(): boolean | undefined;
        renderExtraNode(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
        renderSelect(): import("react").JSX.Element;
        renderSearchInput(valueNodes: import("react").ReactNode, placeholder: string | undefined, inputEl: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>): import("react").JSX.Element;
        renderMenuHeader(): import("react").ReactNode;
        render(): import("react").JSX.Element;
        dataStore: import("@alifd/next/types/select/data-store").default;
        selectDOM: HTMLElement;
        width: string | number;
        popupRef: HTMLDivElement;
        resizeTimeout: number;
        highlightTimer: number | undefined;
        menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
        isAutoComplete: boolean;
        inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
        valueDataSource: {
            value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
            valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
            mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
        };
        componentWillUnmount(): void;
        syncWidth(): void;
        handleResize(): void;
        setDataSource(props: import("@alifd/next/types/select").SelectProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
        setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
        setFirstHightLightKeyForMenu(searchValue?: unknown): void;
        handleChange(value: import("@alifd/next/types/select").DataSourceItem | import("@alifd/next/types/select").DataSourceItem[], args_0: unknown, args_1?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined): void;
        handleMenuBodyClick(): void;
        toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
        scrollMenuIntoView(): void;
        handleSelect(): void;
        handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
        renderMenu(): import("react").JSX.Element;
        renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
        saveSelectRef: (ref: HTMLElement | null) => void;
        saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
        focusInput(): void;
        focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
        beforeOpen(): void;
        beforeClose(): void;
        savePopupRef: (ref: HTMLDivElement) => void;
        shouldAutoWidth(): boolean | undefined;
        context: any;
        setState<K extends keyof import("@alifd/next/types/select/select").SelectState>(state: import("@alifd/next/types/select/select").SelectState | ((prevState: Readonly<import("@alifd/next/types/select/select").SelectState>, props: Readonly<import("@alifd/next/types/select").SelectProps>) => import("@alifd/next/types/select/select").SelectState | Pick<import("@alifd/next/types/select/select").SelectState, K> | null) | Pick<import("@alifd/next/types/select/select").SelectState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("@alifd/next/types/select").SelectProps> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<import("@alifd/next/types/select/select").SelectState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").SelectProps>, prevState: Readonly<import("@alifd/next/types/select/select").SelectState>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
    }, Pick<{
        selectAllYet: boolean;
        componentDidUpdate(prevProps: import("@alifd/next/types/select").SelectProps, prevState: import("@alifd/next/types/select/base").BaseState): void;
        componentDidMount(): void;
        ie9Hack(): void;
        useDetailValue(): boolean;
        hasSearch(): boolean;
        getTagSize(): "small" | "medium" | "large" | undefined;
        handleMenuSelect(keys: string[], item: {
            props: {
                _key: string;
            };
        }): false | void;
        handleItemClick(key: string): void;
        handleSingleSelect(key: string, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
        handleMultipleSelect(keys: import("@alifd/next/types/select").DataSourceItem[] | undefined, triggerType: import("@alifd/next/types/select").VisibleChangeType, key?: string | null | undefined, keepSearchValue?: boolean | undefined): void;
        updateSelectAllYet(value?: unknown): void;
        handleSearchValue(value: string): void;
        handleSearch(value: string, e: import("react").ChangeEvent<HTMLInputElement>): void;
        handleSearchClear(triggerType?: string | undefined): void;
        handleSearchKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
        chooseMultipleItem(key: string): void;
        chooseHighlightItem(proxy: unknown, e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
        handleTagClose(item: import("@alifd/next/types/select").ObjectItem): boolean;
        handleDeleteTag(e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
        handleSelectAll(e: import("react").UIEvent<HTMLElement, UIEvent>): void;
        handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
        afterClose(): void;
        maxTagPlaceholder(selectedValues: import("@alifd/next/types/select").ObjectItem[], totalValues: import("@alifd/next/types/select").ObjectItem[]): string;
        renderValues(): import("react").ReactNode;
        handleWrapClick: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
        handleArrowClick: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
        handleClear: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
        hasClear(): boolean | undefined;
        renderExtraNode(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
        renderSelect(): import("react").JSX.Element;
        renderSearchInput(valueNodes: import("react").ReactNode, placeholder: string | undefined, inputEl: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>): import("react").JSX.Element;
        renderMenuHeader(): import("react").ReactNode;
        render(): import("react").JSX.Element;
        dataStore: import("@alifd/next/types/select/data-store").default;
        selectDOM: HTMLElement;
        width: string | number;
        popupRef: HTMLDivElement;
        resizeTimeout: number;
        highlightTimer: number | undefined;
        menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
        isAutoComplete: boolean;
        inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
        valueDataSource: {
            value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
            valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
            mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
        };
        componentWillUnmount(): void;
        syncWidth(): void;
        handleResize(): void;
        setDataSource(props: import("@alifd/next/types/select").SelectProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
        setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
        setFirstHightLightKeyForMenu(searchValue?: unknown): void;
        handleChange(value: import("@alifd/next/types/select").DataSourceItem | import("@alifd/next/types/select").DataSourceItem[], args_0: unknown, args_1?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined): void;
        handleMenuBodyClick(): void;
        toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
        scrollMenuIntoView(): void;
        handleSelect(): void;
        handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
        renderMenu(): import("react").JSX.Element;
        renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
        saveSelectRef: (ref: HTMLElement | null) => void;
        saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
        focusInput(): void;
        focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
        beforeOpen(): void;
        beforeClose(): void;
        savePopupRef: (ref: HTMLDivElement) => void;
        shouldAutoWidth(): boolean | undefined;
        context: any;
        setState<K extends keyof import("@alifd/next/types/select/select").SelectState>(state: import("@alifd/next/types/select/select").SelectState | ((prevState: Readonly<import("@alifd/next/types/select/select").SelectState>, props: Readonly<import("@alifd/next/types/select").SelectProps>) => import("@alifd/next/types/select/select").SelectState | Pick<import("@alifd/next/types/select/select").SelectState, K> | null) | Pick<import("@alifd/next/types/select/select").SelectState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("@alifd/next/types/select").SelectProps> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<import("@alifd/next/types/select/select").SelectState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").SelectProps>, prevState: Readonly<import("@alifd/next/types/select/select").SelectState>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
    }, "focusInput" | "handleSearchClear">> & {
        Option: typeof import("@alifd/next/types/select/option").default;
        OptionGroup: typeof import("@alifd/next/types/select/option-group").default;
        AutoComplete: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/select").AutoCompleteProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            isInputing: boolean;
            componentDidUpdate(prevProps: import("@alifd/next/types/select").AutoCompleteProps): void;
            shouldControlPopup(props: (Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>) | undefined, type: import("@alifd/next/types/select").VisibleChangeType): void;
            handleMenuSelect(keys: string[]): void;
            handleItemClick(): void;
            handleSelectEvent(key: string, item: import("@alifd/next/types/select").ObjectItem, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
            handleChange: (value: string, proxy: import("@alifd/next/types/select").VisibleChangeType | import("react").ChangeEvent<HTMLElement>, item?: import("@alifd/next/types/select").ObjectItem | undefined) => false | undefined;
            handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
            beforeClose(): void;
            handleTriggerKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
            chooseHighlightItem(): false | undefined;
            hasClear(): boolean | "" | undefined;
            renderSelect(props?: Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>): import("react").JSX.Element;
            render(): import("react").JSX.Element;
            dataStore: import("@alifd/next/types/select/data-store").default;
            selectDOM: HTMLElement;
            width: string | number;
            popupRef: HTMLDivElement;
            resizeTimeout: number;
            highlightTimer: number | undefined;
            menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
            isAutoComplete: boolean;
            inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
            valueDataSource: {
                value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
                valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
                mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
            };
            componentDidMount(): void;
            componentWillUnmount(): void;
            syncWidth(): void;
            handleResize(): void;
            setDataSource(props: import("@alifd/next/types/select").AutoCompleteProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
            setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
            setFirstHightLightKeyForMenu(searchValue?: unknown): void;
            handleMenuBodyClick(): void;
            toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
            scrollMenuIntoView(): void;
            renderMenuHeader(): import("react").ReactNode;
            handleSelect(): void;
            handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            useDetailValue(): boolean;
            renderMenu(): import("react").JSX.Element;
            renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            saveSelectRef: (ref: HTMLElement | null) => void;
            saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
            focusInput(): void;
            focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
            beforeOpen(): void;
            afterClose(): void;
            savePopupRef: (ref: HTMLDivElement) => void;
            shouldAutoWidth(): boolean | undefined;
            context: any;
            setState<K_1 extends keyof import("@alifd/next/types/select/auto-complete").AutoCompleteState>(state: import("@alifd/next/types/select/auto-complete").AutoCompleteState | ((prevState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, props: Readonly<import("@alifd/next/types/select").AutoCompleteProps>) => import("@alifd/next/types/select/auto-complete").AutoCompleteState | Pick<import("@alifd/next/types/select/auto-complete").AutoCompleteState, K_1> | null) | Pick<import("@alifd/next/types/select/auto-complete").AutoCompleteState, K_1> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/select").AutoCompleteProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, prevState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").AutoCompleteProps>, nextState: Readonly<import("@alifd/next/types/select/auto-complete").AutoCompleteState>, nextContext: any): void;
        }, {}>;
        Combobox: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/select").SelectProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            selectAllYet: boolean;
            componentDidUpdate(prevProps: import("@alifd/next/types/select").SelectProps, prevState: import("@alifd/next/types/select/base").BaseState): void;
            componentDidMount(): void;
            ie9Hack(): void;
            useDetailValue(): boolean;
            hasSearch(): boolean;
            getTagSize(): "small" | "medium" | "large" | undefined;
            handleMenuSelect(keys: string[], item: {
                props: {
                    _key: string;
                };
            }): false | void;
            handleItemClick(key: string): void;
            handleSingleSelect(key: string, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
            handleMultipleSelect(keys: import("@alifd/next/types/select").DataSourceItem[] | undefined, triggerType: import("@alifd/next/types/select").VisibleChangeType, key?: string | null | undefined, keepSearchValue?: boolean | undefined): void;
            updateSelectAllYet(value?: unknown): void;
            handleSearchValue(value: string): void;
            handleSearch(value: string, e: import("react").ChangeEvent<HTMLInputElement>): void;
            handleSearchClear(triggerType?: string | undefined): void;
            handleSearchKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
            chooseMultipleItem(key: string): void;
            chooseHighlightItem(proxy: unknown, e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleTagClose(item: import("@alifd/next/types/select").ObjectItem): boolean;
            handleDeleteTag(e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleSelectAll(e: import("react").UIEvent<HTMLElement, UIEvent>): void;
            handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
            afterClose(): void;
            maxTagPlaceholder(selectedValues: import("@alifd/next/types/select").ObjectItem[], totalValues: import("@alifd/next/types/select").ObjectItem[]): string;
            renderValues(): import("react").ReactNode;
            handleWrapClick: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            handleArrowClick: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            handleClear: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            hasClear(): boolean | undefined;
            renderExtraNode(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            renderSelect(): import("react").JSX.Element;
            renderSearchInput(valueNodes: import("react").ReactNode, placeholder: string | undefined, inputEl: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>): import("react").JSX.Element;
            renderMenuHeader(): import("react").ReactNode;
            render(): import("react").JSX.Element;
            dataStore: import("@alifd/next/types/select/data-store").default;
            selectDOM: HTMLElement;
            width: string | number;
            popupRef: HTMLDivElement;
            resizeTimeout: number;
            highlightTimer: number | undefined;
            menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
            isAutoComplete: boolean;
            inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
            valueDataSource: {
                value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
                valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
                mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
            };
            componentWillUnmount(): void;
            syncWidth(): void;
            handleResize(): void;
            setDataSource(props: import("@alifd/next/types/select").SelectProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
            setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
            setFirstHightLightKeyForMenu(searchValue?: unknown): void;
            handleChange(value: import("@alifd/next/types/select").DataSourceItem | import("@alifd/next/types/select").DataSourceItem[], args_0: unknown, args_1?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined): void;
            handleMenuBodyClick(): void;
            toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
            scrollMenuIntoView(): void;
            handleSelect(): void;
            handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            renderMenu(): import("react").JSX.Element;
            renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            saveSelectRef: (ref: HTMLElement | null) => void;
            saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
            focusInput(): void;
            focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
            beforeOpen(): void;
            beforeClose(): void;
            savePopupRef: (ref: HTMLDivElement) => void;
            shouldAutoWidth(): boolean | undefined;
            context: any;
            setState<K extends keyof import("@alifd/next/types/select/select").SelectState>(state: import("@alifd/next/types/select/select").SelectState | ((prevState: Readonly<import("@alifd/next/types/select/select").SelectState>, props: Readonly<import("@alifd/next/types/select").SelectProps>) => import("@alifd/next/types/select/select").SelectState | Pick<import("@alifd/next/types/select/select").SelectState, K> | null) | Pick<import("@alifd/next/types/select/select").SelectState, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/select").SelectProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/select/select").SelectState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").SelectProps>, prevState: Readonly<import("@alifd/next/types/select/select").SelectState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
        }, {}>;
    };
    SplitButton: any;
    Step: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/step").StepProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        step: HTMLOListElement | null;
        componentDidMount(): void;
        componentDidUpdate(): void;
        componentWillUnmount(): void;
        adjustHeight(): void;
        resize(): void;
        _getValidChildren(children: import("react").ReactNode): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
        _stepRefHandler: (ref: HTMLOListElement | null) => void;
        render(): import("react").JSX.Element;
        context: any;
        setState<K extends keyof import("@alifd/next/types/step/types").StepState>(state: import("@alifd/next/types/step/types").StepState | ((prevState: Readonly<import("@alifd/next/types/step/types").StepState>, props: Readonly<import("@alifd/next/types/step").StepProps>) => import("@alifd/next/types/step/types").StepState | Pick<import("@alifd/next/types/step/types").StepState, K> | null) | Pick<import("@alifd/next/types/step/types").StepState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("@alifd/next/types/step").StepProps> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<import("@alifd/next/types/step/types").StepState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/step").StepProps>, nextState: Readonly<import("@alifd/next/types/step/types").StepState>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/step").StepProps>, prevState: Readonly<import("@alifd/next/types/step/types").StepState>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/step").StepProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/step").StepProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/step").StepProps>, nextState: Readonly<import("@alifd/next/types/step/types").StepState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/step").StepProps>, nextState: Readonly<import("@alifd/next/types/step/types").StepState>, nextContext: any): void;
    }, {}> & {
        Item: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/step").ItemProps<HTMLElement> & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            ro: import("resize-observer-polyfill").default;
            container: HTMLDivElement;
            stepNode: HTMLDivElement;
            step: HTMLLIElement;
            body: HTMLDivElement;
            title: HTMLDivElement;
            tail: HTMLDivElement;
            eventHandler: {
                off: () => void;
            } | undefined;
            componentDidMount(): void;
            componentDidUpdate(): void;
            componentWillUnmount(): void;
            adjustItemWidth(): void;
            adjustTail(): void;
            resize(): void;
            _getNode(): {} | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | null;
            getNode(args: {
                stepCls: string;
                overlayCls: {
                    width: string;
                } | null;
                others: Omit<import("@alifd/next/types/step").ItemProps<HTMLElement>, "animation" | "content" | "direction" | "title" | "stretch" | "rtl" | "icon" | "disabled" | "total" | "popupContainer" | "prefix" | "locale" | "pure" | "device" | "errorBoundary" | "warning" | "children" | "defaultPropsConfig" | "className" | "status" | "onClick" | "readOnly" | "shape" | "itemRender" | "percent" | "index" | "labelPlacement" | "parentWidth" | "parentHeight" | "onResize">;
            }): import("react").JSX.Element;
            getStyle(): {
                width: string | number;
            };
            onClick: () => false | undefined;
            removeClickedCls(): void;
            _itemRender(index: number, status: import("@alifd/next/types/step/types").StepStatus): import("react").ReactNode;
            _refHandlerCreator<Name extends "container" | "body" | "title" | "step" | "tail" | "stepNode">(refName: Name): (ref: any[Name]) => void;
            render(): import("react").JSX.Element;
            context: any;
            setState<K_1 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/step").ItemProps<HTMLElement>>) => {} | Pick<{}, K_1> | null) | Pick<{}, K_1> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/step").ItemProps<HTMLElement>> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/step").ItemProps<HTMLElement>>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/step").ItemProps<HTMLElement>>, prevState: Readonly<{}>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/step").ItemProps<HTMLElement>>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/step").ItemProps<HTMLElement>>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/step").ItemProps<HTMLElement>>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/step").ItemProps<HTMLElement>>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
    };
    Switch: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/switch").SwitchProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        readonly props: import("@alifd/next/types/switch").SwitchProps & Required<Pick<import("@alifd/next/types/switch").SwitchProps, "loading" | "prefix" | "disabled" | "size" | "onChange" | "defaultChecked" | "readOnly" | "locale" | "autoWidth" | "isPreview">>;
        onChange(ev: import("react").MouseEvent<HTMLDivElement> | import("react").KeyboardEvent<HTMLDivElement>): void;
        onKeyDown(e: import("react").KeyboardEvent<HTMLDivElement>): void;
        render(): React.JSX.Element;
    }, {}>;
    Tab: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/tab").TabProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        componentDidUpdate(prevProps: import("@alifd/next/types/tab").TabProps): void;
        getDefaultActiveKey(props: import("@alifd/next/types/tab").TabProps): string | undefined;
        getNextActiveKey(isNext: boolean): string | 0 | null;
        isActiveKeyExist(activeKey: string): boolean;
        setActiveKey(key: string): void;
        handleTriggerEvent: (eventType: string, key: string) => void;
        onNavKeyDown: (e: import("react").KeyboardEvent<HTMLElement>) => void;
        render(): import("react").JSX.Element;
        context: any;
        setState<K extends "activeKey">(state: import("@alifd/next/types/tab/tab").TabState | ((prevState: Readonly<import("@alifd/next/types/tab/tab").TabState>, props: Readonly<import("@alifd/next/types/tab").TabProps>) => import("@alifd/next/types/tab/tab").TabState | Pick<import("@alifd/next/types/tab/tab").TabState, K> | null) | Pick<import("@alifd/next/types/tab/tab").TabState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("@alifd/next/types/tab").TabProps> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<import("@alifd/next/types/tab/tab").TabState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").TabProps>, nextState: Readonly<import("@alifd/next/types/tab/tab").TabState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/tab").TabProps>, prevState: Readonly<import("@alifd/next/types/tab/tab").TabState>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tab").TabProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tab").TabProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").TabProps>, nextState: Readonly<import("@alifd/next/types/tab/tab").TabState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").TabProps>, nextState: Readonly<import("@alifd/next/types/tab/tab").TabState>, nextContext: any): void;
    }, {}> & {
        Item: {
            new (props: import("@alifd/next/types/tab").ItemProps | Readonly<import("@alifd/next/types/tab").ItemProps>): {
                _actived: boolean;
                readonly props: import("@alifd/next/types/tab/types").TabItemProps;
                render(): import("react").JSX.Element | null;
                context: any;
                setState<K_1 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/tab").ItemProps>) => {} | Pick<{}, K_1> | null) | Pick<{}, K_1> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                state: Readonly<{}>;
                refs: {
                    [key: string]: import("react").ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/tab").ItemProps>, prevState: Readonly<{}>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/tab").ItemProps>, prevState: Readonly<{}>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): void;
            };
            new (props: import("@alifd/next/types/tab").ItemProps, context: any): {
                _actived: boolean;
                readonly props: import("@alifd/next/types/tab/types").TabItemProps;
                render(): import("react").JSX.Element | null;
                context: any;
                setState<K_1 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/tab").ItemProps>) => {} | Pick<{}, K_1> | null) | Pick<{}, K_1> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                state: Readonly<{}>;
                refs: {
                    [key: string]: import("react").ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/tab").ItemProps>, prevState: Readonly<{}>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/tab").ItemProps>, prevState: Readonly<{}>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): void;
            };
            displayName: string;
            propTypes: {
                prefix: import("prop-types").Requireable<string>;
                title: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
                closeable: import("prop-types").Requireable<boolean>;
                disabled: import("prop-types").Requireable<boolean>;
                active: import("prop-types").Requireable<boolean>;
                lazyLoad: import("prop-types").Requireable<boolean>;
                unmountInactiveTabs: import("prop-types").Requireable<boolean>;
                children: import("prop-types").Requireable<any>;
            };
            defaultProps: {
                prefix: string;
                closeable: boolean;
            };
            contextType?: import("react").Context<any> | undefined;
        };
        TabPane: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/tab").ItemProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            _actived: boolean;
            readonly props: import("@alifd/next/types/tab/types").TabItemProps;
            render(): import("react").JSX.Element | null;
            context: any;
            setState<K_1 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/tab").ItemProps>) => {} | Pick<{}, K_1> | null) | Pick<{}, K_1> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            state: Readonly<{}>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/tab").ItemProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/tab").ItemProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tab").ItemProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
    };
    Table: typeof Table;
    Tree: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/tree").TreeProps<import("@alifd/next/types/tree/types").FieldDataNode<{
        key: string;
        label?: import("react").ReactNode;
    }, "children">> & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/tree/view/tree").Tree, Pick<import("@alifd/next/types/tree/view/tree").Tree, "setFocusKey">> & {
        Node: typeof import("@alifd/next/types/tree/view/tree-node").TreeNode;
    };
    TreeSelect: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/tree-select").TreeSelectProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        tree: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/tree").TreeProps<import("@alifd/next/types/tree/types").FieldDataNode<{
            key: string;
            label?: import("react").ReactNode;
        }, "children">> & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/tree/view/tree").Tree> & Pick<import("@alifd/next/types/tree/view/tree").Tree, "setFocusKey">;
        select: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/select").SelectProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            selectAllYet: boolean;
            componentDidUpdate(prevProps: import("@alifd/next/types/select").SelectProps, prevState: import("@alifd/next/types/select/base").BaseState): void;
            componentDidMount(): void;
            ie9Hack(): void;
            useDetailValue(): boolean;
            hasSearch(): boolean;
            getTagSize(): "small" | "medium" | "large" | undefined;
            handleMenuSelect(keys: string[], item: {
                props: {
                    _key: string;
                };
            }): false | void;
            handleItemClick(key: string): void;
            handleSingleSelect(key: string, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
            handleMultipleSelect(keys: import("@alifd/next/types/select").DataSourceItem[] | undefined, triggerType: import("@alifd/next/types/select").VisibleChangeType, key?: string | null | undefined, keepSearchValue?: boolean | undefined): void;
            updateSelectAllYet(value?: unknown): void;
            handleSearchValue(value: string): void;
            handleSearch(value: string, e: import("react").ChangeEvent<HTMLInputElement>): void;
            handleSearchClear(triggerType?: string | undefined): void;
            handleSearchKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
            chooseMultipleItem(key: string): void;
            chooseHighlightItem(proxy: unknown, e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleTagClose(item: import("@alifd/next/types/select").ObjectItem): boolean;
            handleDeleteTag(e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleSelectAll(e: import("react").UIEvent<HTMLElement, UIEvent>): void;
            handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
            afterClose(): void;
            maxTagPlaceholder(selectedValues: import("@alifd/next/types/select").ObjectItem[], totalValues: import("@alifd/next/types/select").ObjectItem[]): string;
            renderValues(): import("react").ReactNode;
            handleWrapClick: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            handleArrowClick: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            handleClear: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            hasClear(): boolean | undefined;
            renderExtraNode(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            renderSelect(): import("react").JSX.Element;
            renderSearchInput(valueNodes: import("react").ReactNode, placeholder: string | undefined, inputEl: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>): import("react").JSX.Element;
            renderMenuHeader(): import("react").ReactNode;
            render(): import("react").JSX.Element;
            dataStore: import("@alifd/next/types/select/data-store").default;
            selectDOM: HTMLElement;
            width: string | number;
            popupRef: HTMLDivElement;
            resizeTimeout: number;
            highlightTimer: number | undefined;
            menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
            isAutoComplete: boolean;
            inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
            valueDataSource: {
                value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
                valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
                mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
            };
            componentWillUnmount(): void;
            syncWidth(): void;
            handleResize(): void;
            setDataSource(props: import("@alifd/next/types/select").SelectProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
            setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
            setFirstHightLightKeyForMenu(searchValue?: unknown): void;
            handleChange(value: import("@alifd/next/types/select").DataSourceItem | import("@alifd/next/types/select").DataSourceItem[], args_0: unknown, args_1?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined): void;
            handleMenuBodyClick(): void;
            toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
            scrollMenuIntoView(): void;
            handleSelect(): void;
            handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            renderMenu(): import("react").JSX.Element;
            renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            saveSelectRef: (ref: HTMLElement | null) => void;
            saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
            focusInput(): void;
            focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
            beforeOpen(): void;
            beforeClose(): void;
            savePopupRef: (ref: HTMLDivElement) => void;
            shouldAutoWidth(): boolean | undefined;
            context: any;
            setState<K extends keyof import("@alifd/next/types/select/select").SelectState>(state: import("@alifd/next/types/select/select").SelectState | ((prevState: Readonly<import("@alifd/next/types/select/select").SelectState>, props: Readonly<import("@alifd/next/types/select").SelectProps>) => import("@alifd/next/types/select/select").SelectState | Pick<import("@alifd/next/types/select/select").SelectState, K> | null) | Pick<import("@alifd/next/types/select/select").SelectState, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/select").SelectProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/select/select").SelectState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").SelectProps>, prevState: Readonly<import("@alifd/next/types/select/select").SelectState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
        }> & Pick<{
            selectAllYet: boolean;
            componentDidUpdate(prevProps: import("@alifd/next/types/select").SelectProps, prevState: import("@alifd/next/types/select/base").BaseState): void;
            componentDidMount(): void;
            ie9Hack(): void;
            useDetailValue(): boolean;
            hasSearch(): boolean;
            getTagSize(): "small" | "medium" | "large" | undefined;
            handleMenuSelect(keys: string[], item: {
                props: {
                    _key: string;
                };
            }): false | void;
            handleItemClick(key: string): void;
            handleSingleSelect(key: string, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
            handleMultipleSelect(keys: import("@alifd/next/types/select").DataSourceItem[] | undefined, triggerType: import("@alifd/next/types/select").VisibleChangeType, key?: string | null | undefined, keepSearchValue?: boolean | undefined): void;
            updateSelectAllYet(value?: unknown): void;
            handleSearchValue(value: string): void;
            handleSearch(value: string, e: import("react").ChangeEvent<HTMLInputElement>): void;
            handleSearchClear(triggerType?: string | undefined): void;
            handleSearchKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
            chooseMultipleItem(key: string): void;
            chooseHighlightItem(proxy: unknown, e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleTagClose(item: import("@alifd/next/types/select").ObjectItem): boolean;
            handleDeleteTag(e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleSelectAll(e: import("react").UIEvent<HTMLElement, UIEvent>): void;
            handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
            afterClose(): void;
            maxTagPlaceholder(selectedValues: import("@alifd/next/types/select").ObjectItem[], totalValues: import("@alifd/next/types/select").ObjectItem[]): string;
            renderValues(): import("react").ReactNode;
            handleWrapClick: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            handleArrowClick: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            handleClear: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            hasClear(): boolean | undefined;
            renderExtraNode(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            renderSelect(): import("react").JSX.Element;
            renderSearchInput(valueNodes: import("react").ReactNode, placeholder: string | undefined, inputEl: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>): import("react").JSX.Element;
            renderMenuHeader(): import("react").ReactNode;
            render(): import("react").JSX.Element;
            dataStore: import("@alifd/next/types/select/data-store").default;
            selectDOM: HTMLElement;
            width: string | number;
            popupRef: HTMLDivElement;
            resizeTimeout: number;
            highlightTimer: number | undefined;
            menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
            isAutoComplete: boolean;
            inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
            valueDataSource: {
                value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
                valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
                mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
            };
            componentWillUnmount(): void;
            syncWidth(): void;
            handleResize(): void;
            setDataSource(props: import("@alifd/next/types/select").SelectProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
            setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
            setFirstHightLightKeyForMenu(searchValue?: unknown): void;
            handleChange(value: import("@alifd/next/types/select").DataSourceItem | import("@alifd/next/types/select").DataSourceItem[], args_0: unknown, args_1?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined): void;
            handleMenuBodyClick(): void;
            toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
            scrollMenuIntoView(): void;
            handleSelect(): void;
            handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            renderMenu(): import("react").JSX.Element;
            renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            saveSelectRef: (ref: HTMLElement | null) => void;
            saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
            focusInput(): void;
            focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
            beforeOpen(): void;
            beforeClose(): void;
            savePopupRef: (ref: HTMLDivElement) => void;
            shouldAutoWidth(): boolean | undefined;
            context: any;
            setState<K extends keyof import("@alifd/next/types/select/select").SelectState>(state: import("@alifd/next/types/select/select").SelectState | ((prevState: Readonly<import("@alifd/next/types/select/select").SelectState>, props: Readonly<import("@alifd/next/types/select").SelectProps>) => import("@alifd/next/types/select/select").SelectState | Pick<import("@alifd/next/types/select/select").SelectState, K> | null) | Pick<import("@alifd/next/types/select/select").SelectState, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/select").SelectProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/select/select").SelectState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").SelectProps>, prevState: Readonly<import("@alifd/next/types/select/select").SelectState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
        }, "focusInput" | "handleSearchClear">;
        getKeysByValue(value: (string | number | boolean | null | undefined)[]): string[];
        getValueByKeys(keys: string[]): (string | number | boolean | null | undefined)[];
        getFullItemPath(item: import("@alifd/next/types/tree-select/types").DataNode): import("@alifd/next/types/tree-select/types").DataNode[];
        getValueForSelect(value: (string | number | boolean | null | undefined)[]): any[];
        getData(value: (string | number | boolean | null | undefined)[], forSelect?: boolean | undefined): import("@alifd/next/types/select").ObjectItem[];
        getNonExistentValues(): (string | number | boolean | null | undefined)[];
        getNonExistentValueKeys(): any[];
        saveTreeRef(ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/tree").TreeProps<import("@alifd/next/types/tree/types").FieldDataNode<{
            key: string;
            label?: import("react").ReactNode;
        }, "children">> & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/tree/view/tree").Tree> & Pick<import("@alifd/next/types/tree/view/tree").Tree, "setFocusKey">): void;
        saveSelectRef(ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/select").SelectProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            selectAllYet: boolean;
            componentDidUpdate(prevProps: import("@alifd/next/types/select").SelectProps, prevState: import("@alifd/next/types/select/base").BaseState): void;
            componentDidMount(): void;
            ie9Hack(): void;
            useDetailValue(): boolean;
            hasSearch(): boolean;
            getTagSize(): "small" | "medium" | "large" | undefined;
            handleMenuSelect(keys: string[], item: {
                props: {
                    _key: string;
                };
            }): false | void;
            handleItemClick(key: string): void;
            handleSingleSelect(key: string, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
            handleMultipleSelect(keys: import("@alifd/next/types/select").DataSourceItem[] | undefined, triggerType: import("@alifd/next/types/select").VisibleChangeType, key?: string | null | undefined, keepSearchValue?: boolean | undefined): void;
            updateSelectAllYet(value?: unknown): void;
            handleSearchValue(value: string): void;
            handleSearch(value: string, e: import("react").ChangeEvent<HTMLInputElement>): void;
            handleSearchClear(triggerType?: string | undefined): void;
            handleSearchKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
            chooseMultipleItem(key: string): void;
            chooseHighlightItem(proxy: unknown, e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleTagClose(item: import("@alifd/next/types/select").ObjectItem): boolean;
            handleDeleteTag(e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleSelectAll(e: import("react").UIEvent<HTMLElement, UIEvent>): void;
            handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
            afterClose(): void;
            maxTagPlaceholder(selectedValues: import("@alifd/next/types/select").ObjectItem[], totalValues: import("@alifd/next/types/select").ObjectItem[]): string;
            renderValues(): import("react").ReactNode;
            handleWrapClick: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            handleArrowClick: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            handleClear: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            hasClear(): boolean | undefined;
            renderExtraNode(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            renderSelect(): import("react").JSX.Element;
            renderSearchInput(valueNodes: import("react").ReactNode, placeholder: string | undefined, inputEl: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>): import("react").JSX.Element;
            renderMenuHeader(): import("react").ReactNode;
            render(): import("react").JSX.Element;
            dataStore: import("@alifd/next/types/select/data-store").default;
            selectDOM: HTMLElement;
            width: string | number;
            popupRef: HTMLDivElement;
            resizeTimeout: number;
            highlightTimer: number | undefined;
            menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
            isAutoComplete: boolean;
            inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
            valueDataSource: {
                value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
                valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
                mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
            };
            componentWillUnmount(): void;
            syncWidth(): void;
            handleResize(): void;
            setDataSource(props: import("@alifd/next/types/select").SelectProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
            setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
            setFirstHightLightKeyForMenu(searchValue?: unknown): void;
            handleChange(value: import("@alifd/next/types/select").DataSourceItem | import("@alifd/next/types/select").DataSourceItem[], args_0: unknown, args_1?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined): void;
            handleMenuBodyClick(): void;
            toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
            scrollMenuIntoView(): void;
            handleSelect(): void;
            handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            renderMenu(): import("react").JSX.Element;
            renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            saveSelectRef: (ref: HTMLElement | null) => void;
            saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
            focusInput(): void;
            focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
            beforeOpen(): void;
            beforeClose(): void;
            savePopupRef: (ref: HTMLDivElement) => void;
            shouldAutoWidth(): boolean | undefined;
            context: any;
            setState<K extends keyof import("@alifd/next/types/select/select").SelectState>(state: import("@alifd/next/types/select/select").SelectState | ((prevState: Readonly<import("@alifd/next/types/select/select").SelectState>, props: Readonly<import("@alifd/next/types/select").SelectProps>) => import("@alifd/next/types/select/select").SelectState | Pick<import("@alifd/next/types/select/select").SelectState, K> | null) | Pick<import("@alifd/next/types/select/select").SelectState, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/select").SelectProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/select/select").SelectState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").SelectProps>, prevState: Readonly<import("@alifd/next/types/select/select").SelectState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
        }> & Pick<{
            selectAllYet: boolean;
            componentDidUpdate(prevProps: import("@alifd/next/types/select").SelectProps, prevState: import("@alifd/next/types/select/base").BaseState): void;
            componentDidMount(): void;
            ie9Hack(): void;
            useDetailValue(): boolean;
            hasSearch(): boolean;
            getTagSize(): "small" | "medium" | "large" | undefined;
            handleMenuSelect(keys: string[], item: {
                props: {
                    _key: string;
                };
            }): false | void;
            handleItemClick(key: string): void;
            handleSingleSelect(key: string, triggerType: import("@alifd/next/types/select").VisibleChangeType): void;
            handleMultipleSelect(keys: import("@alifd/next/types/select").DataSourceItem[] | undefined, triggerType: import("@alifd/next/types/select").VisibleChangeType, key?: string | null | undefined, keepSearchValue?: boolean | undefined): void;
            updateSelectAllYet(value?: unknown): void;
            handleSearchValue(value: string): void;
            handleSearch(value: string, e: import("react").ChangeEvent<HTMLInputElement>): void;
            handleSearchClear(triggerType?: string | undefined): void;
            handleSearchKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
            chooseMultipleItem(key: string): void;
            chooseHighlightItem(proxy: unknown, e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleTagClose(item: import("@alifd/next/types/select").ObjectItem): boolean;
            handleDeleteTag(e: import("react").UIEvent<HTMLElement, UIEvent>): false | undefined;
            handleSelectAll(e: import("react").UIEvent<HTMLElement, UIEvent>): void;
            handleVisibleChange(visible: boolean, type: import("@alifd/next/types/select").VisibleChangeType): void;
            afterClose(): void;
            maxTagPlaceholder(selectedValues: import("@alifd/next/types/select").ObjectItem[], totalValues: import("@alifd/next/types/select").ObjectItem[]): string;
            renderValues(): import("react").ReactNode;
            handleWrapClick: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            handleArrowClick: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            handleClear: (e: import("react").UIEvent<HTMLElement, UIEvent>) => void;
            hasClear(): boolean | undefined;
            renderExtraNode(): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            renderSelect(): import("react").JSX.Element;
            renderSearchInput(valueNodes: import("react").ReactNode, placeholder: string | undefined, inputEl: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>): import("react").JSX.Element;
            renderMenuHeader(): import("react").ReactNode;
            render(): import("react").JSX.Element;
            dataStore: import("@alifd/next/types/select/data-store").default;
            selectDOM: HTMLElement;
            width: string | number;
            popupRef: HTMLDivElement;
            resizeTimeout: number;
            highlightTimer: number | undefined;
            menuRef: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/menu").MenuProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/menu/view/menu").Menu> | null;
            isAutoComplete: boolean;
            inputRef: import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>;
            valueDataSource: {
                value?: string | number | boolean | (string | number | boolean | null | undefined)[] | null | undefined;
                valueDS?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined;
                mapValueDS?: Record<string, import("@alifd/next/types/select").ObjectItem> | undefined;
            };
            componentWillUnmount(): void;
            syncWidth(): void;
            handleResize(): void;
            setDataSource(props: import("@alifd/next/types/select").SelectProps): import("@alifd/next/types/select/types").NormalizedObjectItem[];
            setVisible(visible: boolean, type?: import("@alifd/next/types/select").VisibleChangeType | undefined): void;
            setFirstHightLightKeyForMenu(searchValue?: unknown): void;
            handleChange(value: import("@alifd/next/types/select").DataSourceItem | import("@alifd/next/types/select").DataSourceItem[], args_0: unknown, args_1?: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | undefined): void;
            handleMenuBodyClick(): void;
            toggleHighlightItem(dir: number): false | import("@alifd/next/types/select/types").NormalizedObjectItem | undefined;
            scrollMenuIntoView(): void;
            handleSelect(): void;
            handleMouseDown: (e: import("react").MouseEvent<HTMLElement, MouseEvent>) => void;
            renderMenu(): import("react").JSX.Element;
            renderMenuItem(dataSource: import("@alifd/next/types/select/types").NormalizedObjectItem[]): import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
            saveSelectRef: (ref: HTMLElement | null) => void;
            saveInputRef: (ref: import("@alifd/next/types/config-provider/types").ConfiguredComponent<import("@alifd/next/types/input").InputProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>> & Pick<import("@alifd/next/types/input/input").default<import("@alifd/next/types/input").InputProps>, "focus" | "getInputNode">) => void;
            focusInput(): void;
            focus(start?: number | undefined, end?: number | undefined, preventScroll?: boolean): void;
            beforeOpen(): void;
            beforeClose(): void;
            savePopupRef: (ref: HTMLDivElement) => void;
            shouldAutoWidth(): boolean | undefined;
            context: any;
            setState<K extends keyof import("@alifd/next/types/select/select").SelectState>(state: import("@alifd/next/types/select/select").SelectState | ((prevState: Readonly<import("@alifd/next/types/select/select").SelectState>, props: Readonly<import("@alifd/next/types/select").SelectProps>) => import("@alifd/next/types/select/select").SelectState | Pick<import("@alifd/next/types/select/select").SelectState, K> | null) | Pick<import("@alifd/next/types/select/select").SelectState, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/select").SelectProps> & Readonly<{
                children?: import("react").ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/select/select").SelectState>;
            refs: {
                [key: string]: import("react").ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): boolean;
            componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/select").SelectProps>, prevState: Readonly<import("@alifd/next/types/select/select").SelectState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/select").SelectProps>, nextState: Readonly<import("@alifd/next/types/select/select").SelectState>, nextContext: any): void;
        }, "focusInput" | "handleSearchClear">): void;
        handleVisibleChange(visible: boolean, type?: string | undefined): void;
        triggerOnChange(value: string | number | boolean | import("@alifd/next/types/select").DataSourceItem[] | import("@alifd/next/types/select").ObjectItem[] | null | undefined, data: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[] | null): void;
        handleSelect(selectedKeys: string[], extra: {
            selected: boolean;
        }): void;
        handleCheck(checkedKeys: string[]): void;
        handleRemove(removedItem: import("@alifd/next/types/select").ObjectItem): void;
        handleSearch(searchedValue: string): void;
        handleSearchClear(triggerType: string): void;
        handleExpand(expandedKeys: string[]): void;
        handleKeyDown(e: import("react").KeyboardEvent<HTMLElement>): void;
        handleChange(value: import("@alifd/next/types/select").DataSourceItem | import("@alifd/next/types/select").DataSourceItem[], triggerType: string): void;
        searchNodes(children: import("react").ReactNode): import("@alifd/next/types/tree/types").NodeElement[];
        createNodesByData(data: import("@alifd/next/types/tree-select/types").TreeSelectDataItem[] | undefined, searching?: boolean | undefined): import("@alifd/next/types/tree/types").NodeElement[];
        renderPopupContent(): import("react").JSX.Element;
        renderPreview(data: import("@alifd/next/types/select").ObjectItem | import("@alifd/next/types/select").ObjectItem[], others: Omit<Readonly<import("@alifd/next/types/tree-select").TreeSelectProps> & Readonly<{
            children?: import("react").ReactNode;
        }>, "label" | "visible" | "size" | "multiple" | "disabled" | "placeholder" | "notFoundContent" | "maxTagPlaceholder" | "popupContainer" | "prefix" | "locale" | "pure" | "children" | "className" | "defaultValue" | "onChange" | "defaultVisible" | "onVisibleChange" | "followTrigger" | "popupStyle" | "popupClassName" | "popupProps" | "value" | "autoWidth" | "readOnly" | "dataSource" | "isPreview" | "renderPreview" | "hasBorder" | "hasClear" | "filterLocal" | "useVirtual" | "hasArrow" | "showSearch" | "onSearch" | "onSearchClear" | "useDetailValue" | "valueRender" | "tagInline" | "immutable" | "treeCheckable" | "clickToCheck" | "preserveNonExistentValue" | "autoClearSearch" | "treeCheckStrictly" | "treeCheckedStrategy" | "treeDefaultExpandAll" | "treeDefaultExpandedKeys" | "treeLoadData" | "treeProps">): import("react").JSX.Element;
        renderMaxTagPlaceholder(value: import("@alifd/next/types/select").ObjectItem[], totalValue: import("@alifd/next/types/select").ObjectItem[]): import("react").ReactNode;
        render(): import("react").JSX.Element;
        context: any;
        setState<K_1 extends keyof import("@alifd/next/types/tree-select/types").TreeSelectState>(state: import("@alifd/next/types/tree-select/types").TreeSelectState | ((prevState: Readonly<import("@alifd/next/types/tree-select/types").TreeSelectState>, props: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps>) => import("@alifd/next/types/tree-select/types").TreeSelectState | Pick<import("@alifd/next/types/tree-select/types").TreeSelectState, K_1> | null) | Pick<import("@alifd/next/types/tree-select/types").TreeSelectState, K_1> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<import("@alifd/next/types/tree-select/types").TreeSelectState>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps>, nextState: Readonly<import("@alifd/next/types/tree-select/types").TreeSelectState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps>, prevState: Readonly<import("@alifd/next/types/tree-select/types").TreeSelectState>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps>, prevState: Readonly<import("@alifd/next/types/tree-select/types").TreeSelectState>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps>, nextState: Readonly<import("@alifd/next/types/tree-select/types").TreeSelectState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/tree-select").TreeSelectProps>, nextState: Readonly<import("@alifd/next/types/tree-select/types").TreeSelectState>, nextContext: any): void;
    }, {}> & {
        Node: typeof import("@alifd/next/types/tree/view/tree-node").TreeNode;
    };
    Upload: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/upload").UploadProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        onSelect: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
        onDrop: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
        selectFiles(files: File[]): void;
        uploadFiles(files: import("@alifd/next/types/upload/types").ObjectFile[]): void;
        startUpload(): void;
        replaceFiles(old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile): void;
        replaceWithNewFile: (old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile) => import("@alifd/next/types/upload/types").ObjectFile;
        isUploading(): boolean;
        onProgress: (e: import("@alifd/next/types/upload/types").UploadProgressEvent, file: import("@alifd/next/types/upload").UploadFile) => void;
        onSuccess: (response: import("@alifd/next/types/upload/types").UploadResponse, file: import("@alifd/next/types/upload").UploadFile) => void;
        onError: (err: import("@alifd/next/types/upload").UploadError, response: import("@alifd/next/types/upload/types").UploadResponse | null, file?: import("@alifd/next/types/upload/types").ObjectFile | undefined) => void;
        removeFile: (file: import("@alifd/next/types/upload").UploadFile) => void;
        updateUploadingState: () => void;
        abort: (file: File) => void;
        onChange: (value: import("@alifd/next/types/upload/types").ObjectFile[], file: import("@alifd/next/types/upload/types").ObjectFile | import("@alifd/next/types/upload/types").ObjectFile[]) => void;
        render(): React.JSX.Element | null;
        uploaderRef: import("@alifd/next/types/upload/types").UploaderRef;
        saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
            getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
        } | null) => void;
        context: any;
        setState<K extends keyof import("@alifd/next/types/upload/types").UploadState>(state: import("@alifd/next/types/upload/types").UploadState | ((prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, props: Readonly<import("@alifd/next/types/upload").UploadProps>) => import("@alifd/next/types/upload/types").UploadState | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null) | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("@alifd/next/types/upload").UploadProps> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<import("@alifd/next/types/upload/types").UploadState>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
    }, {}> & {
        Card: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/upload").CardProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            uploaderRef: {
                onSelect: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                onDrop: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                selectFiles(files: File[]): void;
                uploadFiles(files: import("@alifd/next/types/upload/types").ObjectFile[]): void;
                startUpload(): void;
                replaceFiles(old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile): void;
                replaceWithNewFile: (old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile) => import("@alifd/next/types/upload/types").ObjectFile;
                isUploading(): boolean;
                onProgress: (e: import("@alifd/next/types/upload/types").UploadProgressEvent, file: import("@alifd/next/types/upload").UploadFile) => void;
                onSuccess: (response: import("@alifd/next/types/upload/types").UploadResponse, file: import("@alifd/next/types/upload").UploadFile) => void;
                onError: (err: import("@alifd/next/types/upload").UploadError, response: import("@alifd/next/types/upload/types").UploadResponse | null, file?: import("@alifd/next/types/upload/types").ObjectFile | undefined) => void;
                removeFile: (file: import("@alifd/next/types/upload").UploadFile) => void;
                updateUploadingState: () => void;
                abort: (file: File) => void;
                onChange: (value: import("@alifd/next/types/upload/types").ObjectFile[], file: import("@alifd/next/types/upload/types").ObjectFile | import("@alifd/next/types/upload/types").ObjectFile[]) => void;
                render(): React.JSX.Element | null;
                uploaderRef: import("@alifd/next/types/upload/types").UploaderRef;
                saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
                    getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
                } | null) => void;
                context: any;
                setState<K extends keyof import("@alifd/next/types/upload/types").UploadState>(state: import("@alifd/next/types/upload/types").UploadState | ((prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, props: Readonly<import("@alifd/next/types/upload").UploadProps>) => import("@alifd/next/types/upload/types").UploadState | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null) | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<import("@alifd/next/types/upload").UploadProps> & Readonly<{
                    children?: React.ReactNode;
                }>;
                state: Readonly<import("@alifd/next/types/upload/types").UploadState>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
            };
            componentDidMount(): void;
            componentDidUpdate(): void;
            onProgress: (value: import("@alifd/next/types/upload").UploadFile[], targetItem: import("@alifd/next/types/upload").UploadFile) => void;
            onChange: (value: import("@alifd/next/types/upload").UploadFile[], file: import("@alifd/next/types/upload").UploadFile) => void;
            isUploading(): boolean;
            saveRef(ref: {
                onSelect: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                onDrop: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                selectFiles(files: File[]): void;
                uploadFiles(files: import("@alifd/next/types/upload/types").ObjectFile[]): void;
                startUpload(): void;
                replaceFiles(old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile): void;
                replaceWithNewFile: (old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile) => import("@alifd/next/types/upload/types").ObjectFile;
                isUploading(): boolean;
                onProgress: (e: import("@alifd/next/types/upload/types").UploadProgressEvent, file: import("@alifd/next/types/upload").UploadFile) => void;
                onSuccess: (response: import("@alifd/next/types/upload/types").UploadResponse, file: import("@alifd/next/types/upload").UploadFile) => void;
                onError: (err: import("@alifd/next/types/upload").UploadError, response: import("@alifd/next/types/upload/types").UploadResponse | null, file?: import("@alifd/next/types/upload/types").ObjectFile | undefined) => void;
                removeFile: (file: import("@alifd/next/types/upload").UploadFile) => void;
                updateUploadingState: () => void;
                abort: (file: File) => void;
                onChange: (value: import("@alifd/next/types/upload/types").ObjectFile[], file: import("@alifd/next/types/upload/types").ObjectFile | import("@alifd/next/types/upload/types").ObjectFile[]) => void;
                render(): React.JSX.Element | null;
                uploaderRef: import("@alifd/next/types/upload/types").UploaderRef;
                saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
                    getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
                } | null) => void;
                context: any;
                setState<K extends keyof import("@alifd/next/types/upload/types").UploadState>(state: import("@alifd/next/types/upload/types").UploadState | ((prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, props: Readonly<import("@alifd/next/types/upload").UploadProps>) => import("@alifd/next/types/upload/types").UploadState | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null) | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<import("@alifd/next/types/upload").UploadProps> & Readonly<{
                    children?: React.ReactNode;
                }>;
                state: Readonly<import("@alifd/next/types/upload/types").UploadState>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
            } | null): void;
            updateUploaderRef(uploaderRef: {
                onSelect: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                onDrop: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                selectFiles(files: File[]): void;
                uploadFiles(files: import("@alifd/next/types/upload/types").ObjectFile[]): void;
                startUpload(): void;
                replaceFiles(old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile): void;
                replaceWithNewFile: (old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile) => import("@alifd/next/types/upload/types").ObjectFile;
                isUploading(): boolean;
                onProgress: (e: import("@alifd/next/types/upload/types").UploadProgressEvent, file: import("@alifd/next/types/upload").UploadFile) => void;
                onSuccess: (response: import("@alifd/next/types/upload/types").UploadResponse, file: import("@alifd/next/types/upload").UploadFile) => void;
                onError: (err: import("@alifd/next/types/upload").UploadError, response: import("@alifd/next/types/upload/types").UploadResponse | null, file?: import("@alifd/next/types/upload/types").ObjectFile | undefined) => void;
                removeFile: (file: import("@alifd/next/types/upload").UploadFile) => void;
                updateUploadingState: () => void;
                abort: (file: File) => void;
                onChange: (value: import("@alifd/next/types/upload/types").ObjectFile[], file: import("@alifd/next/types/upload/types").ObjectFile | import("@alifd/next/types/upload/types").ObjectFile[]) => void;
                render(): React.JSX.Element | null;
                uploaderRef: import("@alifd/next/types/upload/types").UploaderRef;
                saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
                    getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
                } | null) => void;
                context: any;
                setState<K extends keyof import("@alifd/next/types/upload/types").UploadState>(state: import("@alifd/next/types/upload/types").UploadState | ((prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, props: Readonly<import("@alifd/next/types/upload").UploadProps>) => import("@alifd/next/types/upload/types").UploadState | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null) | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<import("@alifd/next/types/upload").UploadProps> & Readonly<{
                    children?: React.ReactNode;
                }>;
                state: Readonly<import("@alifd/next/types/upload/types").UploadState>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
            }): void;
            render(): React.JSX.Element;
            abort(file: File): void;
            startUpload(): void;
            saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
                getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
            } | null) => void;
            context: any;
            setState<K_1 extends keyof import("@alifd/next/types/upload/types").CardState>(state: import("@alifd/next/types/upload/types").CardState | ((prevState: Readonly<import("@alifd/next/types/upload/types").CardState>, props: Readonly<import("@alifd/next/types/upload").CardProps>) => import("@alifd/next/types/upload/types").CardState | Pick<import("@alifd/next/types/upload/types").CardState, K_1> | null) | Pick<import("@alifd/next/types/upload/types").CardState, K_1> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/upload").CardProps> & Readonly<{
                children?: React.ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/upload/types").CardState>;
            refs: {
                [key: string]: React.ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextState: Readonly<import("@alifd/next/types/upload/types").CardState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").CardProps>, prevState: Readonly<import("@alifd/next/types/upload/types").CardState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextState: Readonly<import("@alifd/next/types/upload/types").CardState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextState: Readonly<import("@alifd/next/types/upload/types").CardState>, nextContext: any): void;
        }, {}>;
        List: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/upload/types").ListProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            componentDidUpdate(): void;
            handleClose: (file: import("@alifd/next/types/upload/types").ObjectFile) => void;
            handleCancel: (file: import("@alifd/next/types/upload/types").ObjectFile) => void;
            onImageError: (file: import("@alifd/next/types/upload").UploadFile, obj: import("@alifd/next/types/upload/types").ImageError) => void;
            onPreview(file: import("@alifd/next/types/upload").UploadFile, e: React.MouseEvent<HTMLElement, MouseEvent>): void;
            getInfo(file: import("@alifd/next/types/upload/types").ObjectFile): {
                prefixCls: string;
                downloadURL: string | undefined;
                imgURL: string | undefined;
                size: string | number;
                itemCls: string;
                alt: string | undefined;
            };
            sizeCaculator(size: string): string | 0;
            getTextList(file: import("@alifd/next/types/upload/types").ObjectFile): React.JSX.Element;
            getImageList(file: import("@alifd/next/types/upload/types").ObjectFile): React.JSX.Element;
            onSelect: (oldfile: import("@alifd/next/types/upload").UploadFile, files: import("@alifd/next/types/upload").UploadFile[]) => void;
            getPictureCardList(file: import("@alifd/next/types/upload/types").ObjectFile, isPreview?: boolean | undefined): React.JSX.Element;
            render(): React.JSX.Element;
            context: any;
            setState<K_2 extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/upload/types").ListProps>) => {} | Pick<{}, K_2> | null) | Pick<{}, K_2> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/upload/types").ListProps> & Readonly<{
                children?: React.ReactNode;
            }>;
            state: Readonly<{}>;
            refs: {
                [key: string]: React.ReactInstance;
            };
            componentDidMount?(): void;
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload/types").ListProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload/types").ListProps>, prevState: Readonly<{}>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload/types").ListProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload/types").ListProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload/types").ListProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload/types").ListProps>, nextState: Readonly<{}>, nextContext: any): void;
        }, {}>;
        Dragger: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/upload").DraggerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/upload/dragger").default, {}>;
        Selecter: typeof import("@alifd/next/types/upload/runtime/selecter").default;
        Uploader: typeof import("@alifd/next/types/upload/runtime/uploader").default;
        ErrorCode: {
            EXCEED_LIMIT: string;
            BEFOREUPLOAD_REJECT: string;
            RESPONSE_FAIL: string;
        };
        ImageUpload: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/upload").CardProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
            uploaderRef: {
                onSelect: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                onDrop: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                selectFiles(files: File[]): void;
                uploadFiles(files: import("@alifd/next/types/upload/types").ObjectFile[]): void;
                startUpload(): void;
                replaceFiles(old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile): void;
                replaceWithNewFile: (old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile) => import("@alifd/next/types/upload/types").ObjectFile;
                isUploading(): boolean;
                onProgress: (e: import("@alifd/next/types/upload/types").UploadProgressEvent, file: import("@alifd/next/types/upload").UploadFile) => void;
                onSuccess: (response: import("@alifd/next/types/upload/types").UploadResponse, file: import("@alifd/next/types/upload").UploadFile) => void;
                onError: (err: import("@alifd/next/types/upload").UploadError, response: import("@alifd/next/types/upload/types").UploadResponse | null, file?: import("@alifd/next/types/upload/types").ObjectFile | undefined) => void;
                removeFile: (file: import("@alifd/next/types/upload").UploadFile) => void;
                updateUploadingState: () => void;
                abort: (file: File) => void;
                onChange: (value: import("@alifd/next/types/upload/types").ObjectFile[], file: import("@alifd/next/types/upload/types").ObjectFile | import("@alifd/next/types/upload/types").ObjectFile[]) => void;
                render(): React.JSX.Element | null;
                uploaderRef: import("@alifd/next/types/upload/types").UploaderRef;
                saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
                    getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
                } | null) => void;
                context: any;
                setState<K extends keyof import("@alifd/next/types/upload/types").UploadState>(state: import("@alifd/next/types/upload/types").UploadState | ((prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, props: Readonly<import("@alifd/next/types/upload").UploadProps>) => import("@alifd/next/types/upload/types").UploadState | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null) | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<import("@alifd/next/types/upload").UploadProps> & Readonly<{
                    children?: React.ReactNode;
                }>;
                state: Readonly<import("@alifd/next/types/upload/types").UploadState>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
            };
            componentDidMount(): void;
            componentDidUpdate(): void;
            onProgress: (value: import("@alifd/next/types/upload").UploadFile[], targetItem: import("@alifd/next/types/upload").UploadFile) => void;
            onChange: (value: import("@alifd/next/types/upload").UploadFile[], file: import("@alifd/next/types/upload").UploadFile) => void;
            isUploading(): boolean;
            saveRef(ref: {
                onSelect: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                onDrop: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                selectFiles(files: File[]): void;
                uploadFiles(files: import("@alifd/next/types/upload/types").ObjectFile[]): void;
                startUpload(): void;
                replaceFiles(old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile): void;
                replaceWithNewFile: (old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile) => import("@alifd/next/types/upload/types").ObjectFile;
                isUploading(): boolean;
                onProgress: (e: import("@alifd/next/types/upload/types").UploadProgressEvent, file: import("@alifd/next/types/upload").UploadFile) => void;
                onSuccess: (response: import("@alifd/next/types/upload/types").UploadResponse, file: import("@alifd/next/types/upload").UploadFile) => void;
                onError: (err: import("@alifd/next/types/upload").UploadError, response: import("@alifd/next/types/upload/types").UploadResponse | null, file?: import("@alifd/next/types/upload/types").ObjectFile | undefined) => void;
                removeFile: (file: import("@alifd/next/types/upload").UploadFile) => void;
                updateUploadingState: () => void;
                abort: (file: File) => void;
                onChange: (value: import("@alifd/next/types/upload/types").ObjectFile[], file: import("@alifd/next/types/upload/types").ObjectFile | import("@alifd/next/types/upload/types").ObjectFile[]) => void;
                render(): React.JSX.Element | null;
                uploaderRef: import("@alifd/next/types/upload/types").UploaderRef;
                saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
                    getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
                } | null) => void;
                context: any;
                setState<K extends keyof import("@alifd/next/types/upload/types").UploadState>(state: import("@alifd/next/types/upload/types").UploadState | ((prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, props: Readonly<import("@alifd/next/types/upload").UploadProps>) => import("@alifd/next/types/upload/types").UploadState | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null) | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<import("@alifd/next/types/upload").UploadProps> & Readonly<{
                    children?: React.ReactNode;
                }>;
                state: Readonly<import("@alifd/next/types/upload/types").UploadState>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
            } | null): void;
            updateUploaderRef(uploaderRef: {
                onSelect: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                onDrop: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                selectFiles(files: File[]): void;
                uploadFiles(files: import("@alifd/next/types/upload/types").ObjectFile[]): void;
                startUpload(): void;
                replaceFiles(old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile): void;
                replaceWithNewFile: (old: import("@alifd/next/types/upload/types").ObjectFile, current: import("@alifd/next/types/upload").UploadFile) => import("@alifd/next/types/upload/types").ObjectFile;
                isUploading(): boolean;
                onProgress: (e: import("@alifd/next/types/upload/types").UploadProgressEvent, file: import("@alifd/next/types/upload").UploadFile) => void;
                onSuccess: (response: import("@alifd/next/types/upload/types").UploadResponse, file: import("@alifd/next/types/upload").UploadFile) => void;
                onError: (err: import("@alifd/next/types/upload").UploadError, response: import("@alifd/next/types/upload/types").UploadResponse | null, file?: import("@alifd/next/types/upload/types").ObjectFile | undefined) => void;
                removeFile: (file: import("@alifd/next/types/upload").UploadFile) => void;
                updateUploadingState: () => void;
                abort: (file: File) => void;
                onChange: (value: import("@alifd/next/types/upload/types").ObjectFile[], file: import("@alifd/next/types/upload/types").ObjectFile | import("@alifd/next/types/upload/types").ObjectFile[]) => void;
                render(): React.JSX.Element | null;
                uploaderRef: import("@alifd/next/types/upload/types").UploaderRef;
                saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
                    getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
                } | null) => void;
                context: any;
                setState<K extends keyof import("@alifd/next/types/upload/types").UploadState>(state: import("@alifd/next/types/upload/types").UploadState | ((prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, props: Readonly<import("@alifd/next/types/upload").UploadProps>) => import("@alifd/next/types/upload/types").UploadState | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null) | Pick<import("@alifd/next/types/upload/types").UploadState, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<import("@alifd/next/types/upload").UploadProps> & Readonly<{
                    children?: React.ReactNode;
                }>;
                state: Readonly<import("@alifd/next/types/upload/types").UploadState>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").UploadProps>, prevState: Readonly<import("@alifd/next/types/upload/types").UploadState>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").UploadProps>, nextState: Readonly<import("@alifd/next/types/upload/types").UploadState>, nextContext: any): void;
            }): void;
            render(): React.JSX.Element;
            abort(file: File): void;
            startUpload(): void;
            saveUploaderRef: (ref: import("@alifd/next/types/upload/types").UploaderRef | {
                getInstance: () => import("@alifd/next/types/upload/types").UploaderRef;
            } | null) => void;
            context: any;
            setState<K_1 extends keyof import("@alifd/next/types/upload/types").CardState>(state: import("@alifd/next/types/upload/types").CardState | ((prevState: Readonly<import("@alifd/next/types/upload/types").CardState>, props: Readonly<import("@alifd/next/types/upload").CardProps>) => import("@alifd/next/types/upload/types").CardState | Pick<import("@alifd/next/types/upload/types").CardState, K_1> | null) | Pick<import("@alifd/next/types/upload/types").CardState, K_1> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<import("@alifd/next/types/upload").CardProps> & Readonly<{
                children?: React.ReactNode;
            }>;
            state: Readonly<import("@alifd/next/types/upload/types").CardState>;
            refs: {
                [key: string]: React.ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextState: Readonly<import("@alifd/next/types/upload/types").CardState>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload").CardProps>, prevState: Readonly<import("@alifd/next/types/upload/types").CardState>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextState: Readonly<import("@alifd/next/types/upload/types").CardState>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload").CardProps>, nextState: Readonly<import("@alifd/next/types/upload/types").CardState>, nextContext: any): void;
        }, {}>;
        DragUpload: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/upload").DraggerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, import("@alifd/next/types/upload/dragger").default, {}>;
        Core: {
            new (props: import("@alifd/next/types/upload/types").CoreProps): {
                uploader: import("@alifd/next/types/upload/runtime/uploader").default;
                abort(): void;
                handleSelect: (files: import("@alifd/next/types/upload").UploadFile[]) => void;
                render(): React.JSX.Element;
                context: any;
                setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/upload/types").CoreProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
                forceUpdate(callback?: () => void): void;
                readonly props: Readonly<import("@alifd/next/types/upload/types").CoreProps> & Readonly<{
                    children?: import("react").ReactNode | undefined;
                }>;
                state: Readonly<{}>;
                refs: {
                    [key: string]: import("react").ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/upload/types").CoreProps>, nextState: Readonly<{}>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/upload/types").CoreProps>, prevState: Readonly<{}>): any;
                componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/upload/types").CoreProps>, prevState: Readonly<{}>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload/types").CoreProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/upload/types").CoreProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload/types").CoreProps>, nextState: Readonly<{}>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/upload/types").CoreProps>, nextState: Readonly<{}>, nextContext: any): void;
            };
            contextType?: import("react").Context<any> | undefined;
        };
        CropUpload: () => null;
    };
    Divider: import("@alifd/next/types/config-provider/types").ConfiguredComponentClass<import("@alifd/next/types/divider").DividerProps & import("@alifd/next/types/config-provider/types").ComponentCommonProps, {
        render(): React.JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("@alifd/next/types/divider").DividerProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<import("@alifd/next/types/divider").DividerProps> & Readonly<{
            children?: import("react").ReactNode | undefined;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("@alifd/next/types/divider").DividerProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("@alifd/next/types/divider").DividerProps>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<import("@alifd/next/types/divider").DividerProps>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/divider").DividerProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("@alifd/next/types/divider").DividerProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/divider").DividerProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("@alifd/next/types/divider").DividerProps>, nextState: Readonly<{}>, nextContext: any): void;
    }, {}>;
    ContextMenu: ((props: {
        menus: IPublicTypeContextMenuAction[];
        children: React.ReactElement[] | React.ReactElement;
    }) => ReactElement) & {
        create(menus: IPublicTypeContextMenuAction[], event: MouseEvent | React.MouseEvent): void;
    };
    constructor(editor: IEditor);
    get Tip(): typeof InnerTip;
    get HelpTip(): typeof HelpTip;
    get Title(): typeof InnerTitle;
}
